; Status-Bits																															
.equ STATUS_BSY 	=7;    Busy-Flag. Wenn das Bit gesetzt ist, sind alle anderen Bits ungltig und das Laufwerk ist beschftigt.	 	
.equ STATUS_DRDY 	=6;    Drive Ready. Es knnen Befehle zur Festplatte gesendet werden.											  	
.equ STATUS_DF 		=5;    Device Fault. Es ist beim Schreiben von Daten zu einem Fehler gekommen.									  	
.equ STATUS_DSC 	=4;    Drive Seek Complete. Zeigt an, dass das Laufwerk den angeforderten Track gefunden hat und die Schreib-/Lesekpfe dort positioniert hat.  	
.equ STATUS_DRQ 	=3;    Zeigt an, dass Daten zum Laufwerk transportiert werden sollen (beim Schreiben), bzw. dass Daten vom Laufwerk abgeholt werden knnen (beim Lesen).  	
.equ STATUS_COR 	=2;    Corrected Data. Wenn Daten von der Elektronik korrigiert worden sind, wird dieses Bit gesetzt.			  	
.equ STATUS_IDX 	=1;    Index. Wird bei jeder Umdrehung des Plattenstapels auf 1 gesetzt.										  	
.equ STATUS_ERR 	=0;    Error. Das Error-Register muss ausgelesen werden, um nhere Informationen zu erhalten.					  	
; BIT-Codierung																										
.equ CS0=4
.equ CS1=3 		
.equ DA2=2	
.equ DA1=1 
.equ DA0=0
; wichtige Register														  			;/CS0 /CS1 		DA2	DA1 DA0	
.equ Reg_R_Alternate_Status			=(1<<CS0)|(0<<CS1)|	(1<<DA2)|(1<<DA1)|(0<<DA0)	; 1 	0 		1 	1 	0 	
.equ Reg_W_Device_Control			=(1<<CS0)|(0<<CS1)|	(1<<DA2)|(1<<DA1)|(0<<DA0)	; 1 	0 		1 	1 	0 	
.equ Reg_R_NA						=(1<<CS0)|(0<<CS1)|	(1<<DA2)|(1<<DA1)|(1<<DA0)	; 1 	0 		1 	1 	1 	N/A 				N/A						
.equ Reg_W_NA						=(1<<CS0)|(0<<CS1)|	(1<<DA2)|(1<<DA1)|(1<<DA0)	; 1 	0 		1 	1 	1 	N/A 				N/A						
.equ Reg_Data_Register				=(0<<CS0)|(1<<CS1)|	(0<<DA2)|(0<<DA1)|(0<<DA0)	; 0 	1 		0 	0 	0 	Data Register 		Data Register			
.equ Reg_R_Error_Register			=(0<<CS0)|(1<<CS1)|	(0<<DA2)|(0<<DA1)|(1<<DA0)	; 0 	1 		0 	0 	1 	Error Register 		Features Register		
.equ Reg_W_Features_Register		=(0<<CS0)|(1<<CS1)|	(0<<DA2)|(0<<DA1)|(1<<DA0)	; 0 	1 		0 	0 	1 	Error Register 		Features Register		
.equ Reg_Sector_Count				=(0<<CS0)|(1<<CS1)|	(0<<DA2)|(1<<DA1)|(0<<DA0)	; 0 	1 		0 	1 	0 	Sector Count 		Sector Count			
.equ Reg_Sector_Number_LBA0_7		=(0<<CS0)|(1<<CS1)|	(0<<DA2)|(1<<DA1)|(1<<DA0)	; 0 	1 		0 	1 	1 	Sector Number / LBA Bits 0..7 	Sector Number / LBA Bits 0..7
.equ Reg_Cylinder_L_LBA8_15			=(0<<CS0)|(1<<CS1)|	(1<<DA2)|(0<<DA1)|(0<<DA0)	; 0 	1 		1 	0 	0 	Cylinder Low  / LBA Bits 8..15 	Cylinder Low / LBA Bits 8..15
.equ Reg_Cylinder_H_LBA16_23		=(0<<CS0)|(1<<CS1)|	(1<<DA2)|(0<<DA1)|(1<<DA0)	; 0 	1 		1 	0 	1 	Cylinder High / LBA Bits 16..23 	Cylinder High / LBA Bits 16..23
.equ Reg_Device_Register_LBA24_27	=(0<<CS0)|(1<<CS1)|	(1<<DA2)|(1<<DA1)|(0<<DA0)	; 0 	1 		1 	1 	0 	Device Register & LBA Bits 24..27 	Device Register & LBA Bits 24..27
.equ Reg_R_Status_Register			=(0<<CS0)|(1<<CS1)|	(1<<DA2)|(1<<DA1)|(1<<DA0)	; 0 	1 		1 	1 	1 	Status Register 	Command Register 
.equ Reg_W_Command_Register			=(0<<CS0)|(1<<CS1)|	(1<<DA2)|(1<<DA1)|(1<<DA0)	; 0 	1 		1 	1 	1 	Status Register 	Command Register 



;Features Register	Das Features Register bekommt, je nach ausgefhrtem Befehl, eine andere Bedeutung.		
;Cylinder High / LBA Bits 16..23 Hier kommt das High Byte der Zylindernummer rein, wenn man CHS-Adressierung verwendet. Setzt man LBA ein, dann mssen hier die entsprechenden LBA Bits geschrieben werden.
;Cylinder Low / LBA Bits 8..15	Das Low-Byte der Zylindernummer bei CHS-Adressierung; Bits 8..15 bei LBA-Adressierung.	
;Sector Number / LBA Bits 0..7	Wenn man mit CHS arbeitet, muss hier die Sektornummer stehen. Achtung: Sektoren werden von 1 her beginnend Adressiert! Bei LBA werden hier die Bits 0..7 platziert.
;Sector Count Register Hier kann man angeben, wie viele Sektoren man beim nchsten Befehl bertragen mchte. Die Festplatte kann bis 256 Sektoren auf einmal lesen. 

; Device Register & LBA Bits 24..27																							
; Im Device Register stehen folgende Bits:																					
; Bit 7 	Bit 6 	Bit 5 	Bit 4 	Bit 3 	 Bit 2 		Bit 1 		Bit 0													
;	1 		L 		1 		DRV 	H3/LBA27 H2/LBA26 	H1/LBA25 	H0/LBA24												
; L=1=LBA-Modus / (L = 0 =CHS-Adressierung). 																				
; DRV dient zur Adressierung eines Laufwerks, also zur Unterscheidung Master / Slave und ist nur ntig, wenn man 2 Laufwerke an einem Kabel betreibt. 
; DRV = 0 whlt das Master-Laufwerk aus, DRV = 1 adressiert das Slave-Laufwerk. 											
; H0..H3 geben die Nummer des Kopfes an, wenn CHS-Adressierung verwendet wird. Wird LBA verwendet, dann kommen hier die Bits 24..27 hin. 
.equ DR_L 		=6
.equ DR_DRV		=4

.equ Command_Identify_Device= 0xEC ; Gibt Infos wie Modell, Hersteller, Kapazitt... aus	
.equ Command_Read_Sector 	= 0x21 ; Liest die gewnschte Anzahl Sektoren von der Platte	
.equ Command_Read_Sectors 	= 0x20 ; Liest die gewnschte Anzahl Sektoren von der Platte	
.equ Command_Seek 			= 0x70 ; Positioniert die Schreib-/Lesekpfe ber dem angegebenen Sektor								
.equ Command_Standby 		= 0xE2 ; Schaltet die Platte aus. Sie wird autom. wieder aktiv, wenn man ihr einen neuen Befehl sendet.	
.equ Command_Write_Sector 	= 0x30 ; Schreibt die gewnschte Anzahl Sektoren auf die Platte. 										
.equ Command_Write_Sectors 	= 0x31 ; Schreibt die gewnschte Anzahl Sektoren auf die Platte. 										
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_CHECK:
	rjmp IDE_WAIT_BUSHY
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_INITIALISIERUNG:
	OUT (IDE_DATA0_DDR),NULL			; auf Eingang					
	OUT (IDE_DATA0_PORT),VOLL			; Pull-Up on					

	OUT (IDE_DATA1_DDR),NULL			; DATA1 auf Eingang				
	OUT (IDE_DATA1_PORT),VOLL			; Pull-Up on					
	
	sbi(IDE_WR_PORT) ,(IDE_WR_PIN_NR)	; auf HIGH						
	sbi(IDE_RD_PORT) ,(IDE_RD_PIN_NR)
	sbi(IDE_WR_DDR) ,(IDE_WR_PIN_NR)	; auf Ausgang					
	sbi(IDE_RD_DDR) ,(IDE_RD_PIN_NR)
	sbi(IDE_A0_DDR) ,(IDE_A0_PIN_NR)
	sbi(IDE_A1_DDR) ,(IDE_A1_PIN_NR)
	sbi(IDE_A2_DDR) ,(IDE_A2_PIN_NR)
	sbi(IDE_CS0_DDR),(IDE_CS0_PIN_NR)
	sbi(IDE_CS1_DDR),(IDE_CS1_PIN_NR)
	call SECTOR_NULL
	call DATA_CLEAR
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
	call WAIT_100ms
	call LCD_CLEAR
	call LCD_TEXT_IDE
	call LCD_ZEILE2
;-------------------------------------------------------------------------------
	call LCD_0
	in temp,(IDE_DATA0_PIN)
	cpi temp,0xFF			; DATA0 sollte immer HIGH sein	
	breq IDE_INI_D0_OK
	call LCD_AUSRUFEZEICHEN
	call LCD_SPACE
	call WAIT_1s
IDE_INI_D0_OK:		
;-------------------------------------------------------------------------------
	call LCD_1
	in temp,(IDE_DATA1_PIN)
	cpi temp,0xFF			; DATA1 sollte immer HIGH sein	
	breq IDE_INI_D1_OK
	call LCD_AUSRUFEZEICHEN
	call LCD_SPACE
	call WAIT_1s
IDE_INI_D1_OK:
;-------------------------------------------------------------------------------
	call LCD_2
	call IDE_RESET			; RESET							
	tst ERROR
	brne IDE_INITIALISIERUNG
;-------------------------------------------------------------------------------
	call LCD_3
	ldi temp9,255			; Schleife			
IDE_INITIALISIERUNG_s:
	push temp9
	call IDE_IDENTIFY_DRIVE	; IDENTIFY_DRIVE	
	call WAIT_1ms			; Pause wichtig		
	pop temp9
	tst ERROR				; Error ?			
	breq IDE_INITIALISIERUNG_w
	STS(adr_IDE_TAKT_SLOW),EINS	; SLOW !	
	sbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  aus	
	rjmp IDE_INITIALISIERUNG
IDE_INITIALISIERUNG_w:
	call IDE_WAIT_BUSHY
	tst ERROR
	breq IDE_INI_SLOW_OK
	rjmp IDE_INITIALISIERUNG; nochmal	
IDE_INI_SLOW_OK:
	dec temp9
	brne IDE_INITIALISIERUNG_s
;-------------------------------------------------------------------------------
	call LCD_4
	call SECTOR_NULL
	call IDE_SECTOR_READ	; SECTOR_READ	
	tst ERROR
	breq IDE_INI_READ_OK
	call LCD_AUSRUFEZEICHEN
	call LCD_SPACE
	call WAIT_1s
IDE_INI_READ_OK:
;-------------------------------------------------------------------------------
	call LCD_5
	LDS temp1,(adr_IDE_SECTOR_MAX0)
	LDS temp2,(adr_IDE_SECTOR_MAX1)
	LDS temp3,(adr_IDE_SECTOR_MAX2)
	LDS temp4,(adr_IDE_SECTOR_MAX3)	
	call TEMP1_4_NACH_SECTOR
	call IDE_SECTOR_READ	; SECTOR_READ	
	tst ERROR
	breq IDE_INI_READM_OK
	call LCD_AUSRUFEZEICHEN
	call LCD_SPACE
	call WAIT_1s
IDE_INI_READM_OK:
;-------------------------------------------------------------------------------
	call LCD_ZEILE3
	LDS temp,(adr_IDE_CHS_LBA)			; 1=LBA		
	tst temp
	brne IDE_INI_NO_CHS
	call LCD_TEXT_CHS
IDE_INI_NO_CHS:
;-------------------------------------------------------------------------------
	LDS temp,(adr_IDE_TAKT_SLOW)
	tst temp
	breq IDE_INI_NO_SLOW
	call LCD_TEXT_SLOW
IDE_INI_NO_SLOW:
;-------------------------------------------------------------------------------
	call WAIT_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Pause, bei bertragungsfehlern Pause erhhen									
.macro MACRO_IDE_PAUSE
	nop
	nop
.endm
; ##############################################################################
; ##############################################################################
; BSY Busy-Flag. Wenn das Bit gesetzt ist, sind alle anderen Bits ungltig und das Laufwerk ist beschftigt.	 											
; DRDY Drive Ready. Es knnen Befehle zur Festplatte gesendet werden.											  											
; DF 	Device Fault. Es ist beim Schreiben von Daten zu einem Fehler gekommen.									  											
; DSC Drive Seek Complete. Zeigt an, dass das Laufwerk den angeforderten Track gefunden hat und die Schreib-/Lesekpfe dort positioniert hat.  				
; DRQ Zeigt an, dass Daten zum Laufwerk transportiert werden sollen (beim Schreiben), bzw. dass Daten vom Laufwerk abgeholt werden knnen (beim Lesen).  	
; COR Corrected Data. Wenn Daten von der Elektronik korrigiert worden sind, wird dieses Bit gesetzt.			  	
; IDX Index. Wird bei jeder Umdrehung des Plattenstapels auf 1 gesetzt.										  		
; ERR Error. Das Error-Register muss ausgelesen werden, um nhere Informationen zu erhalten.					  	
;																				
;			Bit 7 	Bit 6 	Bit 5 	Bit 4 	Bit 3 	Bit 2 	Bit 1 	Bit 0		
;			BSY 	DRDY 	DF 		DSC 	DRQ 	COR 	IDX 	ERR			
;0x50=OK	0		1		0		1		0		0		0		0			
;0x51=ERR	0		1		0		1		0		0		0		1			
;0xFF=HDD aus																	
IDE_WAIT_BUSHY:
	WDR
	ldi temp1,(Reg_R_Status_Register)			; lscht den Interrupt		
;	ldi temp1,(Reg_R_Alternate_Status)			; ohne Interrupt Lschung	
	rcall IDE_REGISTER_READ_TEMP1
	STS(adr_IDE_REGISTER_STATUS),temp1			; save				
;-------------------------------------------------------------------------------
	SBRS temp1,(STATUS_DRDY)					; DRDY				
	rjmp IDE_WAIT_BUSHY							; Schleife			
	SBRC temp1,(STATUS_BSY)						; BSY				
	rjmp IDE_WAIT_BUSHY							; Schleife			
	andi temp1,0b11111101						; "IDX"-Bit auf NULL
;-------------------------------------------------------------------------------
	SBRC temp1,(STATUS_ERR)						; ERROR?			
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an			
	SBRC temp1,(STATUS_ERR)						; ERROR?			
	rjmp IDE_READ_ERROR							; ja				
;-------------------------------------------------------------------------------
	STS(adr_IDE_REGISTER_ERROR),NULL			; Clear				
	clr ERROR									; Clear				
	ret
;-------------------------------------------------------------------------------
;Error Register																												
;Bit 7 	Bit 6 	Bit 5 	Bit 4 	Bit 3 	Bit 2 	Bit 1 	Bit 0																
;CRC 	UNC 	0 		IDNF 	0 		ABRT 	TK0NF 	AMNF																
;CRC bedeutet, dass bei einem DMA-Transfer ein CRC-Fehler aufgetreten ist. 													
;UNC gibt an, dass bei einer Datenbertragung ein Fehler erkannt worden ist, dieser aber nicht korrigiert werden konnte. 	
;IDNF zeigt an, dass der angeforderte Sektor nicht gefunden worden ist. 													
;ABRT wird auf 1 gesetzt, wenn ein Befehl abgebrochen (aborted) wurde. 														
;TK0NF Zeigt an, dass Track 0 nicht gefunden worden ist. 																	
;AMNF (Address Mark not found): Zeigt an, dass der gewnschte Sektor zwar gefunden wurde, seine Daten aber nicht. 			
;																															
IDE_READ_ERROR:
	ldi temp1,(Reg_R_Error_Register)
	rcall IDE_REGISTER_READ_TEMP1				; Error Register auslesen	
	STS(adr_IDE_REGISTER_ERROR),temp1			; SAVE				
	STS(adr_IDE_REGISTER_ERROR_LAST),temp1		; SAVE				
	ldi temp,(ERROR_IDE_BUSHY)					; Error				
	mov ERROR,temp								; save				
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CHS / LBA																		
IDE_SECTOR_INITIALISIERUNG:
	LDS temp,(adr_IDE_CHS_LBA)	; 0=CHS		
	tst temp
	breq IDE_SECTOR_INITIALISIERUNG_CHS_MODUS
	rjmp IDE_SECTOR_INITIALISIERUNG_LBA_MODUS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: SEKTOR (Register)														
; max 28Bit																		
IDE_SECTOR_INITIALISIERUNG_LBA_MODUS:
	ldi temp1,(Reg_Sector_Count)			; Sector Count initialisieren	
	mov temp2,EINS							; 1 Sector (512 Bytes)			
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
;-------------------------------------------------------------------------------
	ldi temp1,(Reg_Sector_Number_LBA0_7)	; LBA0_7	
	mov temp2,SECTOR0
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
;-------------------------------------------------------------------------------
	ldi temp1,(Reg_Cylinder_L_LBA8_15)		; LBA8_15	
	mov temp2,SECTOR1
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
;-------------------------------------------------------------------------------
	ldi temp1,(Reg_Cylinder_H_LBA16_23)		; LBA16_23	
	mov temp2,SECTOR2
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
;-------------------------------------------------------------------------------
	ldi temp1,(Reg_Device_Register_LBA24_27); LBA24_27	
	mov temp2,SECTOR3
	andi temp2,0b00001111					; begrenzen		
	ldi temp,(1<<DR_L)|(0<<DR_DRV)
	or temp2,temp
	rjmp IDE_REGISTER_WRITE_TEMP1_TEMP2
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: SEKTOR (Register)														
IDE_SECTOR_INITIALISIERUNG_CHS_MODUS:
	; CYL=SEKTOR/(H*S)															
	LDS temp1,(adr_IDE_IDENTIFY_HEAD)	; H			
	LDS temp2,(adr_IDE_IDENTIFY_SEC) 	; S			
	MUL temp1,temp2						; H*S		
	push R0								; sichern, wird dann temp3
	push R1								; sichern, wird dann temp4
	mov temp5,R0						; Divident	
	mov temp6,R1
	call SECTOR_NACH_TEMP1_4			; SEKTOR laden				
	call DIVISION_32_16					; DIVISION	
	STS(adr_IDE_CHS_CYL_L),temp1		; CYL		
	STS(adr_IDE_CHS_CYL_H),temp2
;-------------------------------------------------------------------------------
	; Head=(SEKTOR-(CYL*H*S)):S											
	pop temp4							; H*S						
	pop temp3
	call MULTIPLIKATION_16_16_32		; CYL*H*S					
	mov R0,temp1						; R1						
	mov R1,temp2
	mov R2,temp3
	mov R3,temp4
	call SECTOR_NACH_TEMP1_4			; SEKTOR laden				
	sub temp1,R0						; SEKTOR-R1					
	sbc temp2,R1
	sbc temp3,R2
	sbc temp4,R3
	push temp1							; R2 (sichern)				
	push temp2
	LDS temp5,(adr_IDE_IDENTIFY_SEC)	; durch S					
	clr temp6
	call DIVISION_32_16
	STS(adr_IDE_CHS_HEAD),temp1				; HEAD						
;-------------------------------------------------------------------------------
	; SEC=R2-(HEAD*S)+1	
	LDS temp2,(adr_IDE_IDENTIFY_SEC) 	; S							
	MUL temp1,temp2						; HEAD*S					
	pop temp2							; R2 (wieder herstellen		
	pop temp1
	sub temp1,R0						; R2-(HEAD*S)				
	sbc temp2,R1
	inc temp1							; +1						
	STS(adr_IDE_CHS_SEC),temp1				; SEC						
;-------------------------------------------------------------------------------
; wait BUSHY																	
	rcall IDE_WAIT_BUSHY
;-------------------------------------------------------------------------------
; Sector Count initialisieren													
	ldi temp1,(Reg_Sector_Count)
	mov temp2,EINS						; 1 Sector (512 Bytes)		
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
;-------------------------------------------------------------------------------
; Sector Number schreiben														
	ldi temp1,(Reg_Sector_Number_LBA0_7)	
	LDS temp2,(adr_IDE_CHS_SEC)				; mit 1 beginnend (1...63)	
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
;-------------------------------------------------------------------------------
; Head																			
	ldi temp1,(Reg_Device_Register_LBA24_27)
	LDS temp2,(adr_IDE_CHS_HEAD)			; (0...15)					
	andi temp2,0b00001111				; begrenzen					
	ldi temp,(0<<DR_L)|(0<<DR_DRV)
	or temp2,temp
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
;-------------------------------------------------------------------------------
; Cylinder Low schreiben														
	ldi temp1,(Reg_Cylinder_L_LBA8_15)		
	LDS temp2,(adr_IDE_CHS_CYL_L)
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
;-------------------------------------------------------------------------------
; Cylinder HIGH schreiben														
	ldi temp1,(Reg_Cylinder_H_LBA16_23)		
	LDS temp2,(adr_IDE_CHS_CYL_H)
	rjmp IDE_REGISTER_WRITE_TEMP1_TEMP2
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_SECTOR_WRITE:
	rcall IDE_SECTOR_INITIALISIERUNG
;-------------------------------------------------------------------------------
	ldi temp1,(Reg_W_Command_Register)
	ldi temp2,(Command_Write_Sector)
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
	rcall IDE_WAIT_BUSHY				; wait BUSHY	
;-------------------------------------------------------------------------------
	cbi(IDE_CS0_PORT),(IDE_CS0_PIN_NR)	; CS0=L		; DATA	
	sbi(IDE_CS1_PORT),(IDE_CS1_PIN_NR)	; CS1=H		
	cbi(IDE_A2_PORT) ,(IDE_A2_PIN_NR)	; A2 =L		
	cbi(IDE_A1_PORT) ,(IDE_A1_PIN_NR)	; A1 =L		
	cbi(IDE_A0_PORT) ,(IDE_A0_PIN_NR)	; A0 =L		
;-------------------------------------------------------------------------------
	OUT (IDE_DATA0_DDR),VOLL			; DATA0 auf Ausgang	
	OUT (IDE_DATA1_DDR),VOLL			; DATA1 auf Ausgang	
	ldi ZL,LOW (adr_DATA)				; Z-DATA		
	ldi ZH,HIGH(adr_DATA)
	clr temp9 							; (256)			
;-------------------------------------------------------------------------------
; Schleife																		
IDE_SECTOR_WRITE_s:
	LD temp,Z+
	OUT (IDE_DATA0_PORT),temp			; DATA0 write	
	LD temp,Z+
	OUT (IDE_DATA1_PORT),temp			; DATA1 write	
;-------------------------------------------------------------------------------
	cbi(IDE_WR_PORT) ,(IDE_WR_PIN_NR) 	; WR=L			
	MACRO_IDE_PAUSE						; PAUSE			
	sbi(IDE_WR_PORT) ,(IDE_WR_PIN_NR) 	; WR=H			
;-------------------------------------------------------------------------------
	dec temp9
	brne IDE_SECTOR_WRITE_s
;-------------------------------------------------------------------------------
	OUT (IDE_DATA0_DDR),NULL			; DATA0 auf Eingang				
	OUT (IDE_DATA0_PORT),VOLL			; PULL-UP						
	OUT (IDE_DATA1_DDR),NULL			; DATA1 auf Eingang				
	OUT (IDE_DATA1_PORT),VOLL			; Pull-Up						
;-------------------------------------------------------------------------------
	rcall IDE_WAIT_BUSHY				; wait BUSHY	
	tst ERROR							; ERROR ?		
	brne IDE_SECTOR_WRITE_ERROR
	ret
;-------------------------------------------------------------------------------
IDE_SECTOR_WRITE_ERROR:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_SECTOR_READ:
	rcall IDE_SECTOR_INITIALISIERUNG
;-------------------------------------------------------------------------------
	ldi temp1,(Reg_W_Command_Register)
	ldi temp2,(Command_Read_Sector)
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
	rcall IDE_WAIT_BUSHY				; wait BUSHY	
;-------------------------------------------------------------------------------
IDE_DATA_READ16_512:
	cbi(IDE_CS0_PORT),(IDE_CS0_PIN_NR)	; CS0=L		
	sbi(IDE_CS1_PORT),(IDE_CS1_PIN_NR)	; CS1=H		
	cbi(IDE_A2_PORT) ,(IDE_A2_PIN_NR)	; A2 =L		
	cbi(IDE_A1_PORT) ,(IDE_A1_PIN_NR)	; A1 =L		
	cbi(IDE_A0_PORT) ,(IDE_A0_PIN_NR)	; A0 =L		
;-------------------------------------------------------------------------------
	ldi ZL,LOW (adr_DATA)				; Z-DATA	
	ldi ZH,HIGH(adr_DATA)
	ldi temp9,0 						; (256)		
;-------------------------------------------------------------------------------
; read																			
IDE_DATA_READ16_s:
	cbi(IDE_RD_PORT),(IDE_RD_PIN_NR)	; RD=L		
;-------------------------------------------------------------------------------
; PAUSE, diese ist kritisch, alte Platten mind.4 s								
	LDS temp,(adr_IDE_TAKT_SLOW)		; SLOW ?	
	tst temp
	breq IDE_DATA_READ16_w
	call WAIT_10us						; PAUSE		
;-------------------------------------------------------------------------------
IDE_DATA_READ16_w:
	in temp1,(IDE_DATA0_PIN)			; DATA0 read	
	in temp2,(IDE_DATA1_PIN)			; DATA1 read	
	sbi(IDE_RD_PORT) ,(IDE_RD_PIN_NR)	; RD=H			
	ST Z+,temp1							; DATA0-->Z		
	ST Z+,temp2							; DATA1-->Z		
;-------------------------------------------------------------------------------
	dec temp9							; Schleife		
	brne IDE_DATA_READ16_s	
;-------------------------------------------------------------------------------
	rcall IDE_WAIT_BUSHY				; wait BUSHY	
	tst ERROR							; ERROR	?		
	brne IDE_DATA_READ16_ERROR
	ret
;-------------------------------------------------------------------------------
IDE_DATA_READ16_ERROR:
	call DATA_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1 (IDE-Register)														
; OUT: temp1																	
IDE_REGISTER_READ_TEMP1:
	sbrc temp1,(CS1)					; Skip if Bit	
	sbi(IDE_CS1_PORT),(IDE_CS1_PIN_NR)	; H				
	sbrc temp1,(CS0)					; Skip if Bit	
	sbi(IDE_CS0_PORT),(IDE_CS0_PIN_NR)	; H				
	sbrc temp1,(DA2)					; Skip if Bit	
	sbi(IDE_A2_PORT) ,(IDE_A2_PIN_NR) 	; H				
	sbrc temp1,(DA1)					; Skip if Bit	
	sbi(IDE_A1_PORT) ,(IDE_A1_PIN_NR)	; H				
	sbrc temp1,(DA0)					; Skip if Bit	
	sbi(IDE_A0_PORT) ,(IDE_A0_PIN_NR) 	; H				
;-------------------------------------------------------------------------------
	sbrs temp1,(CS1)					; Skip if Bit	
	cbi(IDE_CS1_PORT),(IDE_CS1_PIN_NR)	; L				
	sbrs temp1,(CS0)					; Skip if Bit	
	cbi(IDE_CS0_PORT),(IDE_CS0_PIN_NR)	; L				
	sbrs temp1,(DA2)					; Skip if Bit	
	cbi(IDE_A2_PORT) ,(IDE_A2_PIN_NR) 	; L				
	sbrs temp1,(DA1)					; Skip if Bit	
	cbi(IDE_A1_PORT) ,(IDE_A1_PIN_NR)	; L				
	sbrs temp1,(DA0)					; Skip if Bit	
	cbi(IDE_A0_PORT) ,(IDE_A0_PIN_NR) 	; L				
;-------------------------------------------------------------------------------
	MACRO_IDE_PAUSE						; PAUSE			
	cbi(IDE_RD_PORT) ,(IDE_RD_PIN_NR)	; RD=L			
	OUT (IDE_DATA0_PORT),VOLL			; PULL-UP on	
	MACRO_IDE_PAUSE						; PAUSE			
	in temp1,(IDE_DATA0_PIN)			; DATA0 read	
	sbi(IDE_RD_PORT) ,(IDE_RD_PIN_NR)	; RD=H			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; temp1: Register																
; temp2: Wert																	
IDE_REGISTER_WRITE_TEMP1_TEMP2:
	OUT (IDE_DATA0_DDR),VOLL			; DATA0 auf Ausgang	
	mov temp,temp2
	OUT (IDE_DATA0_PORT),temp			; DATA0 write	
;-------------------------------------------------------------------------------
	sbrc temp1,(CS1)					; Skip if Bit	
	sbi(IDE_CS1_PORT),(IDE_CS1_PIN_NR)	; H				
	sbrc temp1,(CS0)					; Skip if Bit	
	sbi(IDE_CS0_PORT),(IDE_CS0_PIN_NR)	; H				
	sbrc temp1,(DA2)					; Skip if Bit	
	sbi(IDE_A2_PORT) ,(IDE_A2_PIN_NR) 	; H				
	sbrc temp1,(DA1)					; Skip if Bit	
	sbi(IDE_A1_PORT) ,(IDE_A1_PIN_NR)	; H				
	sbrc temp1,(DA0)					; Skip if Bit	
	sbi(IDE_A0_PORT) ,(IDE_A0_PIN_NR) 	; H				
;-------------------------------------------------------------------------------
	sbrs temp1,(CS1)					; Skip if Bit	
	cbi(IDE_CS1_PORT),(IDE_CS1_PIN_NR)	; L				
	sbrs temp1,(CS0)					; Skip if Bit	
	cbi(IDE_CS0_PORT),(IDE_CS0_PIN_NR)	; L				
	sbrs temp1,(DA2)					; Skip if Bit	
	cbi(IDE_A2_PORT) ,(IDE_A2_PIN_NR) 	; L				
	sbrs temp1,(DA1)					; Skip if Bit	
	cbi(IDE_A1_PORT) ,(IDE_A1_PIN_NR)	; L				
	sbrs temp1,(DA0)					; Skip if Bit	
	cbi(IDE_A0_PORT) ,(IDE_A0_PIN_NR) 	; L				
;-------------------------------------------------------------------------------
	cbi(IDE_WR_PORT) ,(IDE_WR_PIN_NR) 	; WR=L			
	MACRO_IDE_PAUSE						; PAUSE			
	sbi(IDE_WR_PORT) ,(IDE_WR_PIN_NR) 	; WR=H			
;-------------------------------------------------------------------------------
	OUT (IDE_DATA0_DDR),NULL			; auf Eingang	
	OUT (IDE_DATA0_PORT),VOLL			; PULL-UP off	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_SECTOR_OVERLOW_C:
	LDS R0,(adr_IDE_SECTOR_MAX3)
	cp SECTOR3,R0
	brlo IDE_SECTOR_OVERLOW_C_OK	; OK	
	breq IDE_SECTOR_OVERLOW_w2
	rjmp IDE_SECTOR_OVERLOW_C_ERROR	; Error	
IDE_SECTOR_OVERLOW_w2:
	LDS R0,(adr_IDE_SECTOR_MAX2)
	cp SECTOR2,R0
	brlo IDE_SECTOR_OVERLOW_C_OK	; OK	
	breq IDE_SECTOR_OVERLOW_w1
	rjmp IDE_SECTOR_OVERLOW_C_ERROR	; Error	
IDE_SECTOR_OVERLOW_w1:
	LDS R0,(adr_IDE_SECTOR_MAX1)
	cp SECTOR1,R0
	brlo IDE_SECTOR_OVERLOW_C_OK	; OK	
	breq IDE_SECTOR_OVERLOW_w0
	rjmp IDE_SECTOR_OVERLOW_C_ERROR	; Error	
IDE_SECTOR_OVERLOW_w0:
	LDS R0,(adr_IDE_SECTOR_MAX0)
	cp SECTOR0,R0
	brlo IDE_SECTOR_OVERLOW_C_OK	; OK	
	rjmp IDE_SECTOR_OVERLOW_C_ERROR	; Error	
;-------------------------------------------------------------------------------
IDE_SECTOR_OVERLOW_C_ERROR:
	SEC ;Set Carry	
ret
;-------------------------------------------------------------------------------
IDE_SECTOR_OVERLOW_C_OK:
	CLC ;Clear Carry
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Anzeige in %																	
IDE_PROZENT:
	mov temp1,SECTOR0				; Divident	
	mov temp2,SECTOR1
	mov temp3,SECTOR2
	mov temp4,SECTOR3

	LDS temp5,(adr_IDE_SECTOR_MAX0)	; Divisor	
	LDS temp6,(adr_IDE_SECTOR_MAX1)
	LDS temp7,(adr_IDE_SECTOR_MAX2)
	LDS temp8,(adr_IDE_SECTOR_MAX3)
; ------------------------------------------------------------------------------
; Divisor auf 16 Bit krzen														
IDE_PROZENT_s2:	
	LSR temp4				; Divident :2		
	ROR temp3
	ROR temp2
	ROR temp1
	LSR temp8				; Divisor :2		
	ROR temp7
	ROR temp6
	ROR temp5
	tst temp7				; noch 24 Bit?		
	brne IDE_PROZENT_s2
	tst temp8				; noch 32 Bit?		
	brne IDE_PROZENT_s2
; ------------------------------------------------------------------------------
	ldi temp3,LOW (100)
	ldi temp4,high(100)
	call MULTIPLIKATION_16_16_32	; Divident x 100
	call DIVISION_32_16				; Division		
	call LCD_ZAHL_TEMP1_2_3_4		; Ergebnis		
	call LCD_PROZENT
	call LCD_SPACE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
