; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_INFO:
	call LCD_ZEILE1
	call LCD_TEXT_IDE
	call LCD_TEXT_INFO
	LDS temp,(adr_IDE_CHS_LBA)
	tst temp
	brne LCD_ANZEIGE_IDE_IDENTIFY_DRIVE_w
	call LCD_AUSRUFEZEICHEN
	call LCD_C
	call LCD_H
	call LCD_S
	call LCD_AUSRUFEZEICHEN
LCD_ANZEIGE_IDE_IDENTIFY_DRIVE_w:
;-------------------------------------------------------------------------------
	call LCD_ZEILE2
	call LCD_C
	call LCD_H
	call LCD_S
	call LCD_SPACE
	call IDE_IDENTIFY_DRIVE
	LDS temp1,(adr_IDE_IDENTIFY_CYL_L)	; C	
	LDS temp2,(adr_IDE_IDENTIFY_CYL_H)
	call LCD_ZAHL_TEMP1_2
	LDS temp1,(adr_IDE_IDENTIFY_HEAD)	; H	
	call LCD_ZAHL_TEMP1
	LDS temp1,(adr_IDE_IDENTIFY_SEC)	;S	
	call LCD_ZAHL_TEMP1
;-------------------------------------------------------------------------------
	call LCD_ZEILE3
	LDS temp1,(adr_IDE_SECTOR_MAX0)
	LDS temp2,(adr_IDE_SECTOR_MAX1)
	LDS temp3,(adr_IDE_SECTOR_MAX2)
	LDS temp4,(adr_IDE_SECTOR_MAX3)
	call LCD_ZAHL_TEMP1_2_3_4
	call LCD_TEXT_SEC
;-------------------------------------------------------------------------------
	call LCD_ZEILE4
	ldi ZL,LOW (adr_DATA +27*2+0)
	ldi ZH,HIGH(adr_DATA +27*2+0)
	call LCD_ANZEIGE_IDE_IDENTIFY_DRIVE_ASCII
ret
;-------------------------------------------------------------------------------
LCD_ANZEIGE_IDE_IDENTIFY_DRIVE_ASCII:
	ldi temp9,8
LCD_ANZEIGE_IDE_IDENTIFY_DRIVE_s:
	adiw ZL,1
	LD temp,Z
	call LCD_DATA_TEMP
	sbiw ZL,1
	LD temp,Z
	call LCD_DATA_TEMP
	adiw ZL,2
	dec temp9
	brne LCD_ANZEIGE_IDE_IDENTIFY_DRIVE_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bit 7 	Bit 6 	Bit 5 	Bit 4 	Bit 3 	Bit 2 	Bit 1 	Bit 0				
;									  1 	SRST 	nIEN 	  0					
;																			 	
; SRST auf 1, so wird ein Software Reset durchgefhrt. 							
; Mit nIEN kann man die Interrupts ein- oder ausschalten. 						
IDE_RESET:
	ldi temp1,(Reg_W_Device_Control)
	ldi temp2,(0b00001100)			; Reset	on	
	call IDE_REGISTER_WRITE_TEMP1_TEMP2
	call WAIT_100ms					; Pause		
	ldi temp1,(Reg_W_Device_Control)
	ldi temp2,(0b000010000)			; Reset aus	
	call IDE_REGISTER_WRITE_TEMP1_TEMP2
	call WAIT_100ms					; Pause		
	call IDE_WAIT_BUSHY
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;/CS0 /CS1 		DA2	DA1 DA0	Register (Read) 	Register (Write)				
; 0 	1 		1 	1 	1 	Status Register 	Command Register 				
;Standby 	0xE2 	Schaltet die Platte aus. Sie wird autom. wieder aktiv, wenn man ihr einen neuen Befehl sendet. 
IDE_SLEEP:
	ldi temp1,(Reg_W_Command_Register)
	ldi temp2,(Command_Standby)
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
	rcall IDE_WAIT_BUSHY			; wait BUSHY	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_SEEK:																			
	ldi temp1,(Reg_W_Command_Register)
	ldi temp2,(Command_Seek)		; SEEK
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
	rjmp IDE_WAIT_BUSHY				; wait BUSHY	
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_IDENTIFY_DRIVE:
	ldi temp1,(Reg_W_Command_Register)
	ldi temp2,(Command_Identify_Device)
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
	rcall IDE_WAIT_BUSHY				; wait BUSHY	
	rcall IDE_DATA_READ16_512			; Daten auslesen
;-------------------------------------------------------------------------------
; CYL																			
	LDS temp1,(adr_DATA+1*2+0)			; WORD1 LOW		
	LDS temp2,(adr_DATA+1*2+1)			; WORD1 HIGH	
	STS(adr_IDE_IDENTIFY_CYL_L),temp1	; save			
	STS(adr_IDE_IDENTIFY_CYL_H),temp2
;-------------------------------------------------------------------------------
; HEAD																			
	LDS temp1,(adr_DATA+3*2+0)			; WORD3 LOW		
	STS(adr_IDE_IDENTIFY_HEAD),temp1	; save			
;-------------------------------------------------------------------------------
; SEC																			
	LDS temp1,(adr_DATA+6*2+0)			; WORD6 LOW		
	STS(adr_IDE_IDENTIFY_SEC),temp1		; save			
;-------------------------------------------------------------------------------
; SEC max																		
	LDS temp1,(adr_DATA+60*2+0)			; WORD60 LOW	
	LDS temp2,(adr_DATA+60*2+1)			; WORD60 HIGH	
	LDS temp3,(adr_DATA+61*2+0)			; WORD61 LOW	
	LDS temp4,(adr_DATA+61*2+1)			; WORD61 HIGH	
	; CHS / LBA		
	tst temp1
	brne IDE_IDENTIFY_DRIVE_LBA
	tst temp2
	brne IDE_IDENTIFY_DRIVE_LBA
	tst temp3
	brne IDE_IDENTIFY_DRIVE_LBA
	tst temp4
	brne IDE_IDENTIFY_DRIVE_LBA
	rjmp IDE_IDENTIFY_DRIVE_CHS
;-------------------------------------------------------------------------------
; LBA																			
IDE_IDENTIFY_DRIVE_LBA:
	STS(adr_IDE_CHS_LBA),EINS			; 1=LBA		
	call TEMP1_2_3_4_MINUS_EINS			; -1		
	STS(adr_IDE_SECTOR_MAX0),temp1		; LBA		
	STS(adr_IDE_SECTOR_MAX1),temp2
	STS(adr_IDE_SECTOR_MAX2),temp3
	STS(adr_IDE_SECTOR_MAX3),temp4
;-------------------------------------------------------------------------------
	call TEMP1_2_3_4_PLUS_EINS			; +1		
	call TEMP1_2_3_4_DURCH_1000			; durch 1000
	call TEMP1_2_3_4_MAL_512			; x 512		
	call TEMP1_2_3_4_DURCH_1000			; durch 1000
	STS(adr_IDE_CAPACITY_MB0),temp1		; LBA		
	STS(adr_IDE_CAPACITY_MB1),temp2
	STS(adr_IDE_CAPACITY_MB2),temp3
	STS(adr_IDE_CAPACITY_MB3),temp4
ret
;-------------------------------------------------------------------------------
;Berechnung C x H x S															
IDE_IDENTIFY_DRIVE_CHS:
	STS(adr_IDE_CHS_LBA),NULL			; 0=CHS		
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	LDS R0,(adr_IDE_IDENTIFY_CYL_L)		; CYL		
	LDS R1,(adr_IDE_IDENTIFY_CYL_H)
	LDS temp9,(adr_IDE_IDENTIFY_HEAD)	; mal Head	
IDE_IDENTIFY_DRIVE_s:	
	add temp1,R0
	adc temp2,R1
	adc temp3,NULL
	adc temp4,NULL
	dec temp9
	brne IDE_IDENTIFY_DRIVE_s

	LDS temp9,(adr_IDE_IDENTIFY_SEC)	; mal SEC	
	dec temp9
	mov R0,temp1
	mov R1,temp2
	mov R2,temp3
	mov R3,temp4
IDE_IDENTIFY_DRIVE_s1:	
	add temp1,R0
	adc temp2,R1
	adc temp3,R2
	adc temp4,R3
	dec temp9
	brne IDE_IDENTIFY_DRIVE_s1
;-------------------------------------------------------------------------------
	STS(adr_IDE_SECTOR_MAX0),temp1
	STS(adr_IDE_SECTOR_MAX1),temp2
	STS(adr_IDE_SECTOR_MAX2),temp3
	STS(adr_IDE_SECTOR_MAX3),temp4
;-------------------------------------------------------------------------------
	call TEMP1_2_3_4_DURCH_1000			; durch 1000
	call TEMP1_2_3_4_MAL_512			; x 512		
	call TEMP1_2_3_4_DURCH_1000			; durch 1000
	STS(adr_IDE_CAPACITY_MB0),temp1		; LBA		
	STS(adr_IDE_CAPACITY_MB1),temp2
	STS(adr_IDE_CAPACITY_MB2),temp3
	STS(adr_IDE_CAPACITY_MB3),temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_TEST_READ:
	call SECTOR_NULL
	call IDE_SECTOR_READ	; read	
	call ZAHLER_NULL
	call UHR_NULL
;-------------------------------------------------------------------------------
IDE_TEST_READ_s:
	call IDE_SECTOR_READ	; read	
	call ZAHLER_PLUS_EINS
	LDS temp,(adr_ss)
	tst temp
	breq IDE_TEST_READ_s
;-------------------------------------------------------------------------------
	call LCD_ZEILE3
	call ZAHLER_ANZEIGE
	call LCD_TEXT_SEC_PRO_SEC
;-------------------------------------------------------------------------------
	call TASTATUR_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	breq IDE_TEST_READ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_TEST_READ_ALLE:
	call LCD_ZEILE4
	call LCD_TEXT_WAIT
	call WAIT_1ms
	call TASTATUR_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	brne IDE_TEST_READ_ALLE
;-------------------------------------------------------------------------------
.equ SRA=0	; Startsector
	ldi temp1,BYTE1(SRA)
	ldi temp2,BYTE2(SRA)
	ldi temp3,BYTE3(SRA)
	ldi temp4,BYTE4(SRA)
	call TEMP1_4_NACH_SECTOR

	call UHR_NULL
;-------------------------------------------------------------------------------
IDE_TEST_READ_ALLE_s:
	rcall IDE_SECTOR_READ		; read	
	rcall SECTOR_PLUS_EINS		; +1	
	LDS temp,(adr_ss)
	tst SECTOR0
	brne IDE_TEST_READ_ALLE_w
	call LCD_ZEILE2
	call IDE_PROZENT
	call LCD_ZEILE3
	call LCD_ANZEIGE_SECTOR	
	call LCD_ZEILE4
	call LCD_ANZEIGE_ZEIT
	call TASTATUR_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	brne IDE_TEST_READ_ALLE_FERTIG
;-------------------------------------------------------------------------------
IDE_TEST_READ_ALLE_w:
	rcall IDE_SECTOR_OVERLOW_C
	brcc IDE_TEST_READ_ALLE_s
;-------------------------------------------------------------------------------
IDE_TEST_READ_ALLE_FERTIG:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_TEST_SEEK_READ:
	call SECTOR_NULL
	call UHR_NULL
IDE_TEST_SEEK_READ_s:
	call IDE_SEEK
	call IDE_SECTOR_READ
	call WAIT_100us			; PAUSE		
	call SECTOR_PLUS_EINS
	call IDE_SECTOR_OVERLOW_C
	brcs IDE_TEST_SEEK_READ_FERTIG
	tst SECTOR0
	brne IDE_TEST_SEEK_READ_s	; Schleife	
	call LCD_ZEILE2
	call IDE_PROZENT	
	call LCD_ZEILE3
	call LCD_ANZEIGE_SECTOR
	call LCD_ZEILE4
	call LCD_ANZEIGE_ZEIT		
	call TASTATUR_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	breq IDE_TEST_SEEK_READ_s	; Schleife	
IDE_TEST_SEEK_READ_FERTIG:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_TEST_WRITE:
 	call ZUFALLSZAHL			; Kontrollbyte
	call SECTOR_NULL
	call DATA_CLEAR
	call UHR_NULL
;-------------------------------------------------------------------------------
IDE_TEST_WRITE_s:
	STS(adr_DATA+0),SECTOR3	; DATA	
	STS(adr_DATA+1),SECTOR2
	STS(adr_DATA+2),SECTOR1
	STS(adr_DATA+3),SECTOR0
	LDS temp,(adr_ZUFALLSZAHL); Kontrollbyte
	STS(adr_DATA+4),temp
	call IDE_SECTOR_WRITE	; write	
	call SECTOR_PLUS_EINS	; +1	
	LDS temp,(adr_ss)
	tst temp
	breq IDE_TEST_WRITE_s
;-------------------------------------------------------------------------------
	call LCD_ZEILE2
	call LCD_ANZEIGE_SECTOR
	call LCD_TEXT_SEC_PRO_SEC
;-------------------------------------------------------------------------------
IDE_TEST_WRITE_s1:
	call SECTOR_MINUS_EINS		; -1	
	call IDE_SECTOR_READ		; read		
;-------------------------------------------------------------------------------
	LDS temp,(adr_DATA+0)
	cp temp,SECTOR3				; Vegleich	
	brne IDE_TEST_WRITE_ERROR
	LDS temp,(adr_DATA+1)
	cp temp,SECTOR2				; Vegleich	
	brne IDE_TEST_WRITE_ERROR
	LDS temp,(adr_DATA+2)
	cp temp,SECTOR1				; Vegleich	
	brne IDE_TEST_WRITE_ERROR
	LDS temp,(adr_DATA+3)
	cp temp,SECTOR0				; Vegleich	
	brne IDE_TEST_WRITE_ERROR

	LDS temp,(adr_DATA+4)
	LDS temp1,(adr_ZUFALLSZAHL)	; Kontrollbyte
	cp temp,temp1				; Vegleich	
	brne IDE_TEST_WRITE_ERROR
;-------------------------------------------------------------------------------
	tst SECTOR0
	brne IDE_TEST_WRITE_s1
	tst SECTOR1
	brne IDE_TEST_WRITE_s1
	tst SECTOR2
	brne IDE_TEST_WRITE_s1
	tst SECTOR3
	brne IDE_TEST_WRITE_s1
;-------------------------------------------------------------------------------
	call TASTATUR_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	brne IDE_TEST_WRITE_ENDE
	rjmp IDE_TEST_WRITE	
IDE_TEST_WRITE_ENDE:
ret
;-------------------------------------------------------------------------------
IDE_TEST_WRITE_ERROR:
	call LCD_CLEAR
	call LCD_TEXT_ERROR
	call LCD_ZEILE2
	call LCD_ANZEIGE_SECTOR
	call PROGRAMM_STOP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_FORMATIERUNG_LL:
	call LCD_ZEILE1
	call LCD_TEXT_IDE
	call LCD_TEXT_FORMAT
	call SECTOR_NULL
	call UHR_NULL
	call DATA_CLEAR
IDE_FORMATIERUNG_s:
	call IDE_SECTOR_WRITE
	tst SECTOR0
	brne IDE_FORMATIERUNG_w 
;-------------------------------------------------------------------------------
	call LCD_ZEILE2
	call IDE_PROZENT
	call LCD_ZEILE3
	call LCD_ANZEIGE_SECTOR	
	call LCD_ZEILE4
	call LCD_ANZEIGE_ZEIT
	call TASTATUR_ABFRAGE
;-------------------------------------------------------------------------------
IDE_FORMATIERUNG_w:
	call SECTOR_PLUS_EINS
	rcall IDE_SECTOR_OVERLOW_C
	brcc IDE_FORMATIERUNG_s	; Schleife	
	call LCD_TEXT_FERTIG
	call PROGRAMM_STOP

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_KOPIE_NACH_SD:
	call SECTOR_NULL
	call UHR_NULL
;-------------------------------------------------------------------------------
IDE_KOPIE_NACH_SD_s:
	call IDE_SECTOR_READ		; read	
	call SD_SECTOR_WRITE		; WRITE	
	tst SECTOR0
	brne IDE_KOPIE_NACH_SD_w
;-------------------------------------------------------------------------------
	call LCD_ZEILE2
	call LCD_TEXT_IDE
	call IDE_PROZENT
	call LCD_TEXT_SD
	call SD_PROZENT
	call LCD_ZEILE3
	call LCD_ANZEIGE_SECTOR	
	call LCD_ZEILE4
	call LCD_ANZEIGE_ZEIT
	call TASTATUR_ABFRAGE
;-------------------------------------------------------------------------------
IDE_KOPIE_NACH_SD_w:
	call SECTOR_PLUS_EINS
	rcall IDE_SECTOR_OVERLOW_C
	brcs IDE_KOPIE_NACH_SD_FERTIG
	rcall SD_SECTOR_OVERLOW_C
	brcs IDE_KOPIE_NACH_SD_FERTIG
	rjmp IDE_KOPIE_NACH_SD_s
;-------------------------------------------------------------------------------
IDE_KOPIE_NACH_SD_FERTIG:
	call LCD_TEXT_FERTIG
	call PROGRAMM_STOP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
