; CMD0 None(0) R1 No GO_IDLE_STATE Software reset. 
; CMD1 None(0) R1 No SEND_OP_COND Initiate initialization process. 
; ACMD41(*1) *2 R1 No APP_SEND_OP_COND For only SDC. Initiate initialization process. 
; CMD8 *3 R7 No SEND_IF_COND For only SDC V2. Check voltage range. 
; CMD9 None(0) R1 Yes SEND_CSD Read CSD register. 
; CMD10 None(0) R1 Yes SEND_CID Read CID register. 
; CMD12 None(0) R1b No STOP_TRANSMISSION Stop to read data. 
; CMD16 Block length[31:0] R1 No SET_BLOCKLEN Change R/W block size. 
; CMD17 Address[31:0] R1 Yes READ_SINGLE_BLOCK Read a block. 
; CMD18 Address[31:0] R1 Yes READ_MULTIPLE_BLOCK Read multiple blocks. 
; CMD23 Number of blocks[15:0] R1 No SET_BLOCK_COUNT For only MMC. Define number of blocks to transfer with next multi-block read/write command. 
; ACMD23(*1) Number of blocks[22:0] R1 No SET_WR_BLOCK_ERASE_COUNT For only SDC. Define number of blocks to pre-erasewith next multi-block write command. 
; CMD24 Address[31:0] R1 Yes WRITE_BLOCK Write a block. 
; CMD25 Address[31:0] R1 Yes WRITE_MULTIPLE_BLOCK Write multiple blocks. 
; CMD55(*1) None(0) R1 No APP_CMD Leading command of ACMD<n> command. 
; CMD58 None(0) R3 No READ_OCR Read OCR. 										

;OCR, CID, CSD, RCA, DSR and SCR

; 																				
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_CHECK:
	rcall SD_STATUS_C					; read !	
	brcs SD_CHECK_OK
	rcall SD_STATUS_C					; read !	
	brcs SD_CHECK_OK
	rjmp SD_INITIALISIERUNG				; Initialisierung	
;-------------------------------------------------------------------------------
SD_CHECK_OK:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_INITIALISIERUNG:
	clr ERROR
	STS(adr_SD_SDHC_AKTIV),NULL
	STS(adr_SD_SECTOR_MAX0),NULL
	STS(adr_SD_SECTOR_MAX1),NULL
	STS(adr_SD_SECTOR_MAX2),NULL
	STS(adr_SD_SECTOR_MAX3),NULL
	STS(adr_SD_CAPACITY_MB0),NULL
	STS(adr_SD_CAPACITY_MB1),NULL
	STS(adr_SD_CAPACITY_MB2),NULL
	STS(adr_SD_CAPACITY_MB3),NULL
	rcall SPI_TAKT_LOW					; TAKT				
;-------------------------------------------------------------------------------
	rcall SD_CMD0						; RESET				
	tst ERROR
	brne SD_INITIALISIERUNG_NO_CARD
;-------------------------------------------------------------------------------
	call LCD_CLEAR	
	call LCD_TEXT_SD
	rcall SD_CMD8
	tst ERROR
	brne SD_INITIALISIERUNG_NO_CARD
;-------------------------------------------------------------------------------
	rcall SD_ACMD41
	tst ERROR
	breq SD_INITIALISIERUNG_RUN
;-------------------------------------------------------------------------------
	call LCD_1
	rcall SD_CMD1
	tst ERROR
	breq SD_INITIALISIERUNG_RUN
;-------------------------------------------------------------------------------
SD_INITIALISIERUNG_NO_CARD:
	ret
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
SD_INITIALISIERUNG_RUN:
	sbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)	; ROT  aus	
	rcall SPI_TAKT_HIGH						; Takt		
;-------------------------------------------------------------------------------
	call LCD_PUNKT
	rcall SD_SET_BLOCKLEN					; Blocklnge setzen (512Byte)
	tst ERROR
	breq PC+2
	rjmp SD_INITIALISIERUNG_ERROR			; ERROR		
;-------------------------------------------------------------------------------
	call LCD_PUNKT
	call SD_OCR_READ
	tst ERROR
	breq PC+2
	rjmp SD_INITIALISIERUNG_ERROR			; ERROR		
;-------------------------------------------------------------------------------
	call LCD_PUNKT
	rcall SD_CID_READ						; REGISTER CID	(card identification)	
	tst ERROR
	breq PC+2
	rjmp SD_INITIALISIERUNG_ERROR			; ERROR		
;-------------------------------------------------------------------------------
	rcall SD_CSD_READ						; REGISTER CSD  (Card Specific Data)	
	rcall SD_CALC_CSD
	tst ERROR
	breq PC+2
	rjmp SD_INITIALISIERUNG_ERROR			; ERROR		
;-------------------------------------------------------------------------------
	call LCD_PUNKT
	rcall SD_STATUS_C							
	brcs PC+2
	rjmp SD_INITIALISIERUNG_ERROR			; ERROR		
;-------------------------------------------------------------------------------
	call LCD_PUNKT
	call SECTOR_NULL
	call SD_SECTOR_READ
	tst ERROR
	breq PC+2
	rjmp SD_INITIALISIERUNG_ERROR			; ERROR		
;-------------------------------------------------------------------------------
	call LCD_PUNKT
	LDS temp1,(adr_SD_SECTOR_MAX0)
	LDS temp2,(adr_SD_SECTOR_MAX1)
	LDS temp3,(adr_SD_SECTOR_MAX2)
	LDS temp4,(adr_SD_SECTOR_MAX3)
	call TEMP1_4_NACH_SECTOR
	call SD_SECTOR_READ
	tst ERROR
	breq PC+2
	rjmp SD_INITIALISIERUNG_ERROR			; ERROR		
;-------------------------------------------------------------------------------
	call LCD_PUNKT
	LDS temp1,(adr_SD_SECTOR_MAX0)
	LDS temp2,(adr_SD_SECTOR_MAX1)
	LDS temp3,(adr_SD_SECTOR_MAX2)
	LDS temp4,(adr_SD_SECTOR_MAX3)
	call TEMP1_4_NACH_SECTOR
	call SECTOR_PLUS_EINS
	call SD_SECTOR_READ
	tst ERROR
	brne PC+2
	rjmp SD_INITIALISIERUNG_ERROR			; ERROR		
;-------------------------------------------------------------------------------
SD_INITIALISIERUNG_FERTIG:
	sbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)	; ROT  aus	
	clr ERROR
	call LCD_TEXT_OK

	rcall SD_CID_READ						; REGISTER CID	 (card identification)
	call LCD_ZEILE2
	LDS temp,(adr_DATA+3)					; Produkt NAME
	call LCD_DATA_TEMP
	LDS temp,(adr_DATA+4)
	call LCD_DATA_TEMP
	LDS temp,(adr_DATA+5)
	call LCD_DATA_TEMP
	LDS temp,(adr_DATA+6)
	call LCD_DATA_TEMP
	LDS temp,(adr_DATA+7)
	call LCD_DATA_TEMP

	LDS temp,(adr_SD_SDHC_AKTIV)
	tst temp
	breq SD_INITIALISIERUNG_Z3
	call LCD_SPACE
	call LCD_TEXT_SDHC

SD_INITIALISIERUNG_Z3:
	call LCD_ZEILE3
	LDS temp1,(adr_SD_CAPACITY_MB0)
	LDS temp2,(adr_SD_CAPACITY_MB1)
	LDS temp3,(adr_SD_CAPACITY_MB2)
	LDS temp4,(adr_SD_CAPACITY_MB3)
	call LCD_ZAHL_TEMP1_2_3_4
	call LCD_M
	call LCD_B
	call WAIT_1s
ret
;-------------------------------------------------------------------------------
SD_INITIALISIERUNG_ERROR:
	call LCD_CLEAR
	call LCD_TEXT_SD
	call LCD_TEXT_ERROR
	call WAIT_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; IDLE MODUS versetzen															
; software reset command														
; CRC muss bei CMD0 und CMD8 korrekt sein !										
; Send: 0x40 0x00 0x00 0x00 0x00 0x95 (CMD0)									
; Recv: 0x01 (R1-Antwort mit dem "In Idle State"-Bit gesetzt.)					
; (CMD0) 																		
SD_CMD0:
	rcall SPI_CS_HIGH		; CS auf HIGH				
	rcall SPI_CLEAR_HIGH	; mindestens 74 CLOCKS senden, CS und MOSI auf HIGH		
; ------------------------------------------------------------------------------
	ldi temp9,10			; Anzahl (wenn Wert zu gro, dann lange Wartezeit)
SD_CMD0_s1:
	ldi temp1, 0x40+0		; CMD0	
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x95
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	rcall SPI_RX_TEMP		; OUT: temp					
	cpi temp,0x01			; auf  0x01 warten			
	breq SD_CMD0_OK
	call WAIT_1ms			; PAUSE						
	call SPI_CLEAR_HIGH
	dec temp9
	brne SD_CMD0_s1
	rjmp SD_CMD0_ERROR
; ------------------------------------------------------------------------------
SD_CMD0_OK:
	rcall SPI_CLEAR_HIGH
	ret
; ------------------------------------------------------------------------------
SD_CMD0_ERROR:
	ldi temp,(ERROR_CODE_SD_INI)
	mov ERROR,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Nun muss die Karte in den Betriebsmodus versetzt werden.						
; CMD1 funktioniert bei allen MMCs und allen "dicken\ SDKarten.					
; Fur die dunnen (1,4mm) SD-Karten ist CMD1 ein illegales Kommando.			
; Send: 0x41 0x00 0x00 0x00 0x00 0x01 (CMD1)									
; Recv: 0x00 (R1-Antwort, jetzt ohne "In Idle State")							
; (CMD1) 																		
SD_CMD1:
	ldi temp9,10			; Anzahl (wenn Wert zu gro, dann lange Wartezeit)
SD_CMD1_s:
	ldi temp1, 0x40+1		; CMD1
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x01
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	rcall SPI_RX_TEMP		; OUT: temp
	cpi temp,0x00				; auf  0x00 warten			
	breq SD_CMD1_OK
	rcall SPI_CLEAR_HIGH
	dec temp9
	brne SD_CMD1_s
	rjmp SD_CMD1_ERROR
; ------------------------------------------------------------------------------
SD_CMD1_OK:
	rcall SPI_CLEAR_HIGH
	ret
; ------------------------------------------------------------------------------
SD_CMD1_ERROR:
	ldi temp,(ERROR_CODE_SD_INI)
	mov ERROR,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD8 wird nur zum Initialisieren von SDHC-Karten mit							
; einer Kapazitt von 4GB und mehr gebraucht									
; CRC muss bei CMD0 und CMD8 korrekt sein !										
;- Voltage check																
;- Enabling expansion of existing command and response							
; Send: 0x48 0x00 0x00 0x01 0xAA 0x87 											
; Recv: 0x01 0x00 0x00 0x01 0xAA												
; (CMD8) 																		
SD_CMD8:	
	ldi temp1, 0x40+8				; CMD8							
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x01					; Voltage supplied (VHS) 2.7-3.6V
	ldi temp5, 0xAA					; Check pattern (Prfmuster)	
	ldi temp6, 0x87
	rcall SD_TX_KOMMANDO_TEMP1_6 	; INP:temp1...6 OUT: temp
	rcall SPI_RX_TEMP				; OUT: temp
	rcall SPI_RX_TEMP				; OUT: temp
	rcall SPI_RX_TEMP				; OUT: temp
	rcall SPI_RX_TEMP				; OUT: temp
	rcall SPI_RX_TEMP				; OUT: temp
;	cpi temp,0xAA
;	brne SD_CMD8_ERROR
; ------------------------------------------------------------------------------
SD_CMD8_OK:
	rcall SPI_CLEAR_HIGH
ret
; ------------------------------------------------------------------------------
SD_CMD8_ERROR:
	rcall SPI_CLEAR_HIGH
	ldi temp,(ERROR_CODE_SD_INI)
	mov ERROR,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Nun muss die Karte in den Betriebsmodus versetzt werden.						
; Send: 0x77 0x00 0x00 0x00 0x00 0x01 (CMD55, das "Prefix" fr ein ACMD)		
; Recv: 0x01 (R1-noch "In Idle State")											
; Send: 0x69 0x00 0x00 0x00 0x00 0x01 (ACMD41)									
; Recv: 0x01 (R1-noch "In Idle State")											
; ....																			
; Send: 0x77 0x00 0x00 0x00 0x00 0x01											
; Recv: 0x01 oder 0x00															
; Send: 0x69 0x00 0x00 0x00 0x00 0x01											
; Recv: 0x00 (R1-Antwort, jetzt ohne "In Idle State")							
; (ACMD41) 																		
SD_ACMD41:
	ldi temp9,10			; Anzahl (wenn Wert zu gro, dann lange Wartezeit)
SD_ACMD41_s:
	rcall SD_CMD55_PREFIX_ACMD
	ldi temp1, 0x69
	ldi temp2, 0x40 ;0x00 nur SDSC // 0x40 SDSC und SDHC
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x01
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	rcall SPI_RX_TEMP		; OUT: temp
	cpi temp, 0x00
	breq SD_ACMD41_OK
	rcall SPI_CLEAR_HIGH
	dec temp9
	brne SD_ACMD41_s
	rjmp SD_ACMD41_ERROR
; ------------------------------------------------------------------------------
SD_ACMD41_OK:
	rcall SPI_CLEAR_HIGH
	ret
; ------------------------------------------------------------------------------
SD_ACMD41_ERROR:
	rcall SPI_CLEAR_HIGH
	ldi temp,(ERROR_CODE_SD_INI)
	mov ERROR,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD55 das "Prefix" fr ein ACMD												
SD_CMD55_PREFIX_ACMD:
	ldi temp1, 0x77
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x01
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	rcall SPI_CLEAR_HIGH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CSD - Register auslesen (Card Specific Data)									
; max. data transfer rate (TRAN_SPEED)  32h, 5Ah, 0Bh or 2Bh [103:96] 8 Bit		
; "CSD_STRUCTURE" herausfiltern	[127:126]										
; "C_SIZE" herausfiltern [69:48] 22bit											
; "READ_BL_LEN" herausfiltern [83:80] 4Bit										
; "C_SIZE" herausfiltern [73:62] 12Bit											
; "C_SIZE_MULT" herausfiltern [49:47] 											
; (CMD9)																		
SD_CSD_READ:
	ldi temp1, 0x40+9			; CMD9	  0x49, 0x00, 0x00, 0x00, 0x00, 0x00
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x00
	call SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp	
; ------------------------------------------------------------------------------
	ldi temp1,(0xFE)				; auf  0xFE warten
	rcall SPI_WAIT_TEMP1_C
	brcs SD_CMD9_OK
	rjmp SD_CMD9_ERROR
; ------------------------------------------------------------------------------
SD_CMD9_OK:
	rcall SPI_RX512_DATA
	rcall SPI_WAIT_FF_HIGH
	clr ERROR
	ret
; ------------------------------------------------------------------------------
SD_CMD9_ERROR:
	rcall SPI_CLEAR_HIGH
	ldi temp,(ERROR_CODE_SD_INI)
	mov ERROR,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bit 31 - 1 if the card power up procedure has been finished.					
; Bit 30 - 0=SDSC. 1=SDHC/SDXC 													
; (CMD58)																		
SD_OCR_READ:
	ldi temp1, 0x40+58			
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x00
	call SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp	
	rcall SPI_RX_TEMP			; OUT: temp
	tst temp
	brne SD_CMD58_ERROR
	rcall SPI_RX_TEMP			; OUT: temp
	andi temp,0b01000000		; SDSC/SDHC
	STS(adr_SD_SDHC_AKTIV),temp
	rcall SPI_RX_TEMP			; OUT: temp
	rcall SPI_RX_TEMP			; OUT: temp
	rcall SPI_RX_TEMP			; OUT: temp
	rcall SPI_CLEAR_HIGH
	ret
; ------------------------------------------------------------------------------
SD_CMD58_ERROR:
	rcall SPI_CLEAR_HIGH
	ldi temp,(ERROR_CODE_SD_INI)
	mov ERROR,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CID - Register auslesen (card identification)									
; Manufacturer ID MID 8 [127:120]												
; Product name PNM [103:64] 40													
; Product serial number PSN [55:24] 32											
; Manufacturing date MDT [19:8] 12												
; Manufacturing date MDT [19:8] 12												
; (CMD10)																		
SD_CID_READ:
	ldi temp1, 0x40+10			; CMD10
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x00
	call SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	ldi temp1,(0xFE)				; auf  0xFE warten
	rcall SPI_WAIT_TEMP1_C
	brcs SD_CMD10_OK
	rjmp SD_CMD10_ERROR
; ------------------------------------------------------------------------------
SD_CMD10_OK:
	rcall SPI_RX512_DATA
	rcall SPI_WAIT_FF_HIGH
	clr ERROR
ret
; ------------------------------------------------------------------------------
SD_CMD10_ERROR:
	rcall SPI_CLEAR_HIGH
	ldi temp,(ERROR_CODE_SD_INI)
	mov ERROR,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Stop to read data																
; (CMD12)																		
SD_CMD12:
	ldi temp1, 0x40+12
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x02
	ldi temp5, 0x00
	ldi temp6, 0x00
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	ldi temp1,(0x00)				; auf  0x00 warten	
	rcall SPI_WAIT_TEMP1_C
	rcall SPI_CLEAR_HIGH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Addressed card sends its status register.										
; OUT Cary	OK=set																
; (CMD13)																		
SD_STATUS_C:
	ldi temp1, 0x40+13			; CMD13 (SEND_STATUS)
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x00
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	rcall SPI_RX_TEMP
	mov temp1,temp
	rcall SPI_RX_TEMP
	mov temp2,temp
	rcall SPI_RX_TEMP
	mov temp3,temp
	call SPI_CS_HIGH			; CS high
	; Auswertung				
	cpi temp1,(0x00)
	brne SD_STATUS_READ_ERROR
	cpi temp2,(0x00)
	brne SD_STATUS_READ_ERROR
	cpi temp3,(0xFF)
	brne SD_STATUS_READ_ERROR
; ------------------------------------------------------------------------------
	SEC 					; Set Carry		
	ret
; ------------------------------------------------------------------------------
SD_STATUS_READ_ERROR:
	CLC 					; Clear Carry	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Sends an addressed card into the Inactive State.								
; (CMD15)																		
SD_CMD15:
	ldi temp1, 0x40+15			
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x00
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	rcall SPI_WAIT_FF_HIGH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Blocklnge setzen (512Byte)													
; (CMD16)																		
SD_SET_BLOCKLEN:
	ldi temp1, 0x40+16
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x02
	ldi temp5, 0x00
	ldi temp6, 0x00
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	rcall SPI_RX_TEMP			; OUT: temp			
	cpi temp,0x00				; auf  0x00 warten	
	breq SD_CMD16_OK
	rjmp SD_CMD16_ERROR
; ------------------------------------------------------------------------------
SD_CMD16_OK:
	rcall SPI_WAIT_FF_HIGH
	clr ERROR
	ret
; ------------------------------------------------------------------------------
SD_CMD16_ERROR:
	rcall SPI_CLEAR_HIGH
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	ldi temp,(ERROR_CODE_SD_BLOCKLAENGE)
	mov ERROR,temp
	rcall SD_ANZEIGE_ERROR
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; http://elm-chan.org/docs/mmc/mmc_e.html										
; Reads a block of the size selected by the SET_BLOCKLEN command				
; 512 BYTES einlesen															
; INP: SEKTOR0...3																
; (CMD17)																		
SD_SECTOR_READ:
	tst ERROR
	breq SD_SECTOR_READ_START
	ret
; ------------------------------------------------------------------------------
SD_SECTOR_READ_START:
	ldi temp1, 0x51
	ldi temp6, 0x00
	rcall SD_SET_PHYS_ADRESSE			; Umrechnung auf phys. Adresse	
	rcall SD_TX_KOMMANDO_TEMP1_6 		; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	ldi temp1,(0xFE)					; auf  0xFE warten		
	rcall SPI_WAIT_TEMP1_C
	brcc SD_SEKTOR_READ_ERROR
; ------------------------------------------------------------------------------
	rcall SPI_RX512_DATA				; read DATA				
	rjmp SPI_WAIT_FF_HIGH				; auf  0xFF warten		
; ------------------------------------------------------------------------------
SD_SEKTOR_READ_ERROR:
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR	; ROT  an				
	ldi temp,(ERROR_CODE_SD_READ)
	mov ERROR,temp
	rcall SPI_CLEAR_HIGH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 512 BYTES write																
; INP: SECTOR																	
; OUT: ERROR																	
; (CMD24)																		
SD_SECTOR_WRITE:
	tst ERROR
	breq SD_SECTOR_WRITE_START
	ret
; ------------------------------------------------------------------------------
SD_SECTOR_WRITE_START:
	ldi temp1, 0x40+24					; CMD24		
	ldi temp6, 0x00
	rcall SD_SET_PHYS_ADRESSE			; Umrechnung auf phys. Adresse	
	rcall SD_TX_KOMMANDO_TEMP1_6 		; INP:temp1...6 OUT: temp	
; ------------------------------------------------------------------------------
	ldi temp1,(0x00)					; auf  0x00 warten
	rcall SPI_WAIT_TEMP1_C
	brcc SD_SECTOR_WRITE_ERROR
; ------------------------------------------------------------------------------
	ldi temp,0xFE						; xFE senden		
	rcall SPI_TX_RX_TEMP				; INP/OUT: TEMP		
	rcall SPI_TX512_DATA				; 512 Bytes senden	
; ------------------------------------------------------------------------------
	ldi temp1,(0xE5)					; auf  0xE5 warten
	rcall SPI_WAIT_TEMP1_C
	brcc SD_SECTOR_WRITE_ERROR
; ------------------------------------------------------------------------------
	ldi temp1,(0xFF)					; auf  0xFF warten	
	rcall SPI_WAIT_TEMP1_C
	brcc SD_SECTOR_WRITE_ERROR
	rjmp SPI_WAIT_FF_HIGH				; auf  0xFF warten	
; ------------------------------------------------------------------------------
SD_SECTOR_WRITE_ERROR:
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)	; ROT  an	
	rcall SPI_CLEAR_HIGH
	ldi temp,(ERROR_CODE_SD_WRITE)		; ERROR-CODE	
	mov ERROR,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; http://elm-chan.org/docs/mmc/mmc_e.html										
; Continuously transfers data blocks from card to host until interrupted by a STOP_TRANSMISSION command.
; CMD18- READ_MULTIPLE_BLOCK															
; INP: SD_SEKTOR																
; START + DATA... + STOP														
SD_CMD18_SEKTOR_READ_MULTIPLE_START:
	ldi temp1, 0x40+18				; CMD18	
	ldi temp6, 0x00
	rcall SD_SET_PHYS_ADRESSE		; Umrechnung auf phys. Adresse	
	rjmp SD_TX_KOMMANDO_TEMP1_6 	; INP:temp1...6 OUT: temp		
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_CMD18_SEKTOR_READ_MULTIPLE_DATA:
	ldi temp1,(0xFE)				; auf  0xFE warten	
	rcall SPI_WAIT_TEMP1_C
	brcc SD_CMD18_SEKTOR_READ_MULTIPLE_ERROR
	rjmp SPI_RX512_DATA				; read DATA			
; ------------------------------------------------------------------------------
SD_CMD18_SEKTOR_READ_MULTIPLE_ERROR:
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	ldi temp,(ERROR_CODE_SD_READ_MULTIPLE)
	mov ERROR,temp
	rcall SD_ANZEIGE_ERROR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_CMD18_SEKTOR_READ_MULTIPLE_STOP:
	call SD_CMD12
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; (CMD25)																		
; INP: SD_SEKTOR																
; OUT: ERROR																	
SD_CMD25_SEKTOR_WRITE_MULTIPLE_START:
	ldi temp1, 0x40+25				; CMD25	
	ldi temp6, 0x00
	rcall SD_SET_PHYS_ADRESSE		; Umrechnung auf phys. Adresse	
	rcall SD_TX_KOMMANDO_TEMP1_6 	; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	ldi temp1,(0x00)				; auf  0x00 warten
	rcall SPI_WAIT_TEMP1_C
	brcc SD_CMD25_SEKTOR_WRITE_MULTIPLE_ERROR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_CMD25_SEKTOR_WRITE_MULTIPLE_DATA:
	ldi temp,0b11111100				; Start Block Token senden		
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP		
	rcall SPI_TX512_DATA			; 512 Bytes senden	
	ldi temp1,(0xE5)				; auf  0xE5 warten
	rcall SPI_WAIT_TEMP1_C
	brcc SD_CMD25_SEKTOR_WRITE_MULTIPLE_ERROR
	ldi temp1,(0xFF)				; auf  0xFF warten	
	rcall SPI_WAIT_TEMP1_C
	brcc SD_CMD25_SEKTOR_WRITE_MULTIPLE_ERROR
ret
; ------------------------------------------------------------------------------
SD_CMD25_SEKTOR_WRITE_MULTIPLE_ERROR:
	ldi temp,(ERROR_CODE_SD_WRITE_MULTIPLE)
	mov ERROR,temp
	rcall SD_ANZEIGE_ERROR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_CMD25_SEKTOR_WRITE_MULTIPLE_STOP:
	ldi temp,0b11111101				; STOP Block Token senden	
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP		
	rcall SPI_WAIT_FF_HIGH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: SD_SEKTOR																
; OUT: temp2+3+4+5																
SD_SET_PHYS_ADRESSE:
	LDS temp,(adr_SD_SDHC_AKTIV)
	tst temp
	breq SD_SET_PHYS_SDSC
	mov temp2,SECTOR3
	mov temp3,SECTOR2	
	mov temp4,SECTOR1	
	mov temp5,SECTOR0	
ret
; ------------------------------------------------------------------------------
; Umrechnen von SEKTOR in physikalische ADRESSE	 (mal 512 (9xlinks))			
SD_SET_PHYS_SDSC:
	mov temp2,SECTOR2		; 8xlinks		
	mov temp3,SECTOR1	
	mov temp4,SECTOR0	
	clr temp5				; LOW			

	LSL temp5				; LOW 1xlinks	
	ROL temp4
	ROL temp3
	ROL temp2				; HIGH			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; INP: temp1...6																
;																				
SD_TX_KOMMANDO_TEMP1_6:
	rcall SPI_CS_LOW				; CS auf LOW !!		
	mov temp,temp1					; temp1...6 senden	
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP
	mov temp,temp2
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP
	mov temp,temp3
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP
	mov temp,temp4
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP
	mov temp,temp5
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP
	mov temp,temp6
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP
	; DUMMY					
	rcall SPI_RX_TEMP			; OUT: temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: ERROR																	
SD_ANZEIGE_ERROR:
	call LCD_CLEAR
	call LCD_TEXT_SD
	call LCD_TEXT_ERROR
	call LCD_ZEILE2
	mov temp1,ERROR
	call LCD_HEX_TEMP1
	call WAIT_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_CALC_CSD:
	call SD_CSD_READ
	ldi ZL,LOW (adr_DATA+15)	; Initialisierung	
	ldi ZH,HIGH(adr_DATA+15)
; "CSD_STRUCTURE" herausfiltern	[127:126]										
	ldi temp8,126						; START	
	ldi temp9,127						; ENDE	
	call FUNKTION_SRAM_SELECT_Z_8_9		; temp8=START	temp9=ENDE
	cpi temp1,0							; Version1
	breq SD_CALC_CSD_VERSION1
	cpi temp1,1							; Version2
	breq SD_CALC_CSD_VERSION2
ret
; ------------------------------------------------------------------------------
; ------------------------------------------------------------------------------
; "C_SIZE" herausfiltern [69:48]												
; memory capacity = (C_SIZE+1) * 512KByte										
SD_CALC_CSD_VERSION2:
	call LCD_V
	call LCD_2
	ldi temp8,48						; START	
	ldi temp9,69						; ENDE	
	call FUNKTION_SRAM_SELECT_Z_8_9	; temp8=START	temp9=ENDE
	; memory capacity = (C_SIZE+1) * 512KByte
	add temp1,EINS
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
	ldi temp9,9
SD_CALC_CSD_s:
	LSL temp1			; x2
	ROL temp2
	ROL temp3
	ROL temp4
	dec temp9
	brne SD_CALC_CSD_s
; Sectoren													
	push temp1
	push temp2
	push temp3
	push temp4
	call TEMP1_2_3_4_MAL_2		; mal 2	
	sub temp1,EINS				; -1	
	sbc temp2,NULL
	sbc temp3,NULL
	sbc temp4,NULL
	STS(adr_SD_SECTOR_MAX0),temp1
	STS(adr_SD_SECTOR_MAX1),temp2
	STS(adr_SD_SECTOR_MAX2),temp3
	STS(adr_SD_SECTOR_MAX3),temp4	
	pop temp4
	pop temp3
	pop temp2
	pop temp1
; Capacity													
	call TEMP1_2_3_4_DURCH_1000	; durch 1000
	STS(adr_SD_CAPACITY_MB0),temp1
	STS(adr_SD_CAPACITY_MB1),temp2
	STS(adr_SD_CAPACITY_MB2),temp3
	STS(adr_SD_CAPACITY_MB3),temp4	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ------------------------------------------------------------------------------
; ------------------------------------------------------------------------------
; "READ_BL_LEN" herausfiltern [83:80] 4Bit										
SD_CALC_CSD_VERSION1:
	call LCD_V
	call LCD_1
	ldi temp8,80						; START	
	ldi temp9,83						; ENDE	
	call FUNKTION_SRAM_SELECT_Z_8_9		; temp8=START	temp9=ENDE
	STS(adr_SD_CSD_READ_BL_LEN),temp1
; "C_SIZE" herausfiltern [73:62] 12Bit											
	ldi temp8,62						; START	
	ldi temp9,73						; ENDE	
	call FUNKTION_SRAM_SELECT_Z_8_9		; temp8=START	temp9=ENDE
	STS(adr_SD_CSD_C_SIZE_0),temp1
	STS(adr_SD_CSD_C_SIZE_1),temp2
; "C_SIZE_MULT" herausfiltern [49:47] 											
	ldi temp8,47						; START	
	ldi temp9,49						; ENDE	
	call FUNKTION_SRAM_SELECT_Z_8_9		; temp8=START	temp9=ENDE
	STS(adr_SD_CSD_C_SIZE_MULT),temp1
; MULT = 2^(C_SIZE_MULT+2) 		(C_SIZE_MULT < 8)	
	mov temp9,temp1
	subi temp9,(-2)		; +2
	ldi temp1,LOW (1)
	ldi temp2,HIGH(1)
SD_CMD9_MU:
	LSL temp1			; links	
	ROL temp2
	dec temp9
	brne SD_CMD9_MU
	STS(adr_SD_CSD_MULT_L),temp1
	STS(adr_SD_CSD_MULT_H),temp2
; memory capacity = BLOCKNR * BLOCK_LEN											
; BLOCKNR = (C_SIZE+1) * MULT													
; MULT = 2^(C_SIZE_MULT+2) 		(C_SIZE_MULT < 8)								
; BLOCK_LEN = 2^(READ_BL_LEN) 	(READ_BL_LEN < 12)								
;																				
	; BLOCKNR = (C_SIZE+1) * MULT												
	LDS temp1,(adr_SD_CSD_C_SIZE_0)
	LDS temp2,(adr_SD_CSD_C_SIZE_1)
	add temp1,EINS
	adc temp2,NULL
	LDS temp3,(adr_SD_CSD_MULT_L)
	LDS temp4,(adr_SD_CSD_MULT_H)
	call MULTIPLIKATION_16_16_32
	; BLOCK_LEN = 2^(READ_BL_LEN) 	(READ_BL_LEN < 12)
	LDS temp9,(adr_SD_CSD_READ_BL_LEN)
SD_CMD9_BL:
	LSL temp1			; links	
	ROL temp2
	ROL temp3
	ROL temp4
	dec temp9
	brne SD_CMD9_BL
; Sectoren													
	push temp1
	push temp2
	push temp3
	push temp4
	call TEMP1_2_3_4_DURCH_512	; :512	
	sub temp1,EINS				; -1	
	sbc temp2,NULL
	sbc temp3,NULL
	sbc temp4,NULL
	STS(adr_SD_SECTOR_MAX0),temp1
	STS(adr_SD_SECTOR_MAX1),temp2
	STS(adr_SD_SECTOR_MAX2),temp3
	STS(adr_SD_SECTOR_MAX3),temp4	
	pop temp4
	pop temp3
	pop temp2
	pop temp1
; Capacity													
	call TEMP1_2_3_4_DURCH_1000	; durch 1000
	call TEMP1_2_3_4_DURCH_1000	; durch 1000
	STS(adr_SD_CAPACITY_MB0),temp1
	STS(adr_SD_CAPACITY_MB1),temp2
	STS(adr_SD_CAPACITY_MB2),temp3
	STS(adr_SD_CAPACITY_MB3),temp4	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_SECTOR_OVERLOW_C:
	LDS R0,(adr_SD_SECTOR_MAX3)
	cp SECTOR3,R0
	brlo SD_SECTOR_OVERLOW_C_OK		; OK	
	breq SD_SECTOR_OVERLOW_w2
	rjmp SD_SECTOR_OVERLOW_C_ERROR	; Error	
SD_SECTOR_OVERLOW_w2:
	LDS R0,(adr_SD_SECTOR_MAX2)
	cp SECTOR2,R0
	brlo SD_SECTOR_OVERLOW_C_OK		; OK	
	breq SD_SECTOR_OVERLOW_w1
	rjmp SD_SECTOR_OVERLOW_C_ERROR	; Error	
SD_SECTOR_OVERLOW_w1:
	LDS R0,(adr_SD_SECTOR_MAX1)
	cp SECTOR1,R0
	brlo SD_SECTOR_OVERLOW_C_OK		; OK	
	breq SD_SECTOR_OVERLOW_w0
	rjmp SD_SECTOR_OVERLOW_C_ERROR	; Error	
SD_SECTOR_OVERLOW_w0:
	LDS R0,(adr_SD_SECTOR_MAX0)
	cp SECTOR0,R0
	brlo SD_SECTOR_OVERLOW_C_OK		; OK	
	rjmp SD_SECTOR_OVERLOW_C_ERROR	; Error	
;-------------------------------------------------------------------------------
SD_SECTOR_OVERLOW_C_ERROR:
	SEC ;Set Carry	
ret
;-------------------------------------------------------------------------------
SD_SECTOR_OVERLOW_C_OK:
	CLC ;Clear Carry
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Anzeige in %																	
SD_PROZENT:
	mov temp1,SECTOR0				; Divident	
	mov temp2,SECTOR1
	mov temp3,SECTOR2
	mov temp4,SECTOR3

	LDS temp5,(adr_SD_SECTOR_MAX0)	; Divisor	
	LDS temp6,(adr_SD_SECTOR_MAX1)
	LDS temp7,(adr_SD_SECTOR_MAX2)
	LDS temp8,(adr_SD_SECTOR_MAX3)
; ------------------------------------------------------------------------------
; Divisor auf 16 Bit krzen														
SD_PROZENT_s2:	
	LSR temp4				; Divident :2		
	ROR temp3
	ROR temp2
	ROR temp1
	LSR temp8				; Divisor :2		
	ROR temp7
	ROR temp6
	ROR temp5
	tst temp7				; noch 24 Bit?		
	brne SD_PROZENT_s2
	tst temp8				; noch 32 Bit?		
	brne SD_PROZENT_s2
; ------------------------------------------------------------------------------
	ldi temp3,LOW (100)
	ldi temp4,high(100)
	call MULTIPLIKATION_16_16_32	; Divident x 100
	call DIVISION_32_16				; Division		
	call LCD_ZAHL_TEMP1_2_3_4		; Ergebnis		
	call LCD_PROZENT
	call LCD_SPACE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
