; GRAFIC-FARBEN									
.equ FARBE_SCHWARZ			= 1
.equ FARBE_BLAU				= 2
.equ FARBE_ROT				= 3 
.equ FARBE_GRUEN			= 4
.equ FARBE_GELB				= 7
.equ FARBE_WEISS			= 8
.equ FARBE_GRAU				= 16
; #############################################################################
; #############################################################################
; #############################################################################
TFT_INITIALISIEREN:
	; ZEILE1	
	call LCD_CLEAR
	call LCD_T
	call LCD_F
	call LCD_T
	call LCD_SPACE
	ldi temp1,(TWI_ADRESSE_TFT)
	rcall TWI_MT_START_TEMP1	; 
	rcall TWI_STOP
	tst ERROR_TWI
	breq TFT_INITIALISIEREN_OK
	call LCD_n_
	call LCD_o_
	call LCD_t_
	call LCD_SPACE
	call LCD_F
	call LCD_o_
	call LCD_u_
	call LCD_n_
	call LCD_d_
	call WAIT_1s
	ret
;-----------------------------------------------------------------------------
TFT_INITIALISIEREN_OK:
	call LCD_TEXT_OK
	call TFT_CLEAR
	call TFT_CURSOR_OFF
	call TFT_HELL
	call TFT_ANZEIGE_BEGRUESSUNG
ret
; #############################################################################
; #############################################################################
; #############################################################################
TFT_CLEAR:
	ldi temp,12
	rcall TFT_DATA_TEMP
	rjmp  TFT_PAKET_SENDEN
;######################################################################## 
;######################################################################## 
;######################################################################## 
TFT_ZAHL_TEMP1:
	clr temp2
TFT_ZAHL_TEMP1_2:
	clr temp3
TFT_ZAHL_TEMP1_2_3:
	clr temp4
TFT_ZAHL_TEMP1_2_3_4:
	rjmp TFT_ZAHL_FORMATIERT
;######################################################################## 
;######################################################################## 
;######################################################################## 
TFT_ZAHL_FORMATIERT:
	call FUNKTION_HEX_ASC_32
	cpi temp,'0'
	brne TFT_ZAHL_10
	cpi temp9,'0'
	brne TFT_ZAHL_9
	cpi temp8,'0'
	brne TFT_ZAHL_8
	cpi temp7,'0'
	brne TFT_ZAHL_7
	cpi temp6,'0'
	brne TFT_ZAHL_6
	cpi temp5,'0'
	brne TFT_ZAHL_5
	cpi temp4,'0'
	brne TFT_ZAHL_4
	cpi temp3,'0'
	brne TFT_ZAHL_3
	cpi temp2,'0'
	brne TFT_ZAHL_2
	rjmp TFT_ZAHL_1
;######################################################################## 
;######################################################################## 
;######################################################################## 
TFT_ZAHL_10:
	rcall TFT_DATA_TEMP	; 10.Ziffer	
	rcall TFT_PUNKT		; Punkt		
TFT_ZAHL_9:
	mov temp, temp9			; 9.Ziffer	
	rcall TFT_DATA_TEMP
TFT_ZAHL_8:
	mov temp, temp8			; 8.Ziffer	
	rcall TFT_DATA_TEMP	
TFT_ZAHL_7:
	mov temp, temp7			; 7.Ziffer	
	rcall TFT_DATA_TEMP	
	rcall TFT_PUNKT		; Punkt		
TFT_ZAHL_6:
	mov temp, temp6			; 6.Ziffer	
	rcall TFT_DATA_TEMP	
TFT_ZAHL_5:
	mov temp, temp5			; 5.Ziffer	
	rcall TFT_DATA_TEMP	
TFT_ZAHL_4:
	mov temp, temp4			; 4.Ziffer	
	rcall TFT_DATA_TEMP	
	rcall TFT_PUNKT		; Punkt		
TFT_ZAHL_3:
	mov temp, temp3			; 3.Ziffer	
	rcall TFT_DATA_TEMP	
TFT_ZAHL_2:
	mov temp, temp2			; 2.Ziffer	
	rcall TFT_DATA_TEMP	
TFT_ZAHL_1:
	mov temp, temp1			; 1.Ziffer (1-er Stelle)	
	rcall TFT_DATA_TEMP
	rjmp TFT_SPACE
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; INP: temp1																
; OUT: (z.B."FF") 															
;																			
; rcall ANZEIGE_HEX_TEMP1 ; inp: temp1										
;																			
TFT_HEX_TEMP1:
	; SICHERUNGSKOPIE						
	push temp
	push temp1
	; oberes NIBBLE bearbeiten				
	mov temp,temp1	
	swap temp						; NIBBLES tausch	
	rcall TFT_HEX_UMWANDLUNG	; INP/OUT: temp		
	rcall TFT_DATA_TEMP
	; unteres NIBBLE bearbeiten				
	mov temp,temp1	
	rcall TFT_HEX_UMWANDLUNG	; INP/OUT: temp		
	rcall TFT_DATA_TEMP
	; SICHERUNGSKOPIE wieder herstellen		
	pop temp1
	pop temp
	ret
;-------------------------------------------------------------------------------
TFT_HEX_UMWANDLUNG:
	; BITMUSTER	
	andi temp,0b00001111
	; vergleich	
	cpi temp,10
	brsh TFT_HEX_UMWANDLUNG_A_F
TFT_HEX_UMWANDLUNG_0_9:
	subi temp,-48
	ret
TFT_HEX_UMWANDLUNG_A_F:
	subi temp,-48-7
	ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; #############################################################################
; #############################################################################
; #############################################################################
TFT_TFT_ELEMENT_ZEICHNEN_Z:
	rcall TFT_ESC
	; WERT aus Tabelle laden		
	LPM temp, Z+  	;(LOW)	z.B: 'G'
	rcall TFT_DATA_TEMP
	LPM temp, Z+  	;DUMMY	
	; WERT aus Tabelle laden		
	LPM temp, Z+  	;(LOW)	z.B: 'D'
	rcall TFT_DATA_TEMP
	LPM temp, Z+  	;DUMMY	
	; WERT aus Tabelle laden		
	LPM temp, Z+  	;(LOW)		x1	
	mov XL,temp
	rcall TFT_DATA_TEMP
	LPM temp, Z+  	;(HIGH)	
	mov XH,temp
	rcall TFT_DATA_TEMP
	; WERT aus Tabelle laden		
	LPM temp, Z+  	;(LOW)		y1	
	mov YL,temp
	rcall TFT_DATA_TEMP
	LPM temp, Z+  	;(HIGH)	
	mov YH,temp
	rcall TFT_DATA_TEMP
	; WERT aus Tabelle laden		
	LPM temp1, Z+  	;(LOW)	X2	
	LPM temp2, Z+  	;(HIGH)
	add XL,temp1
	adc XH,temp2
	mov temp,XL
	rcall TFT_DATA_TEMP
	mov temp,XH
	rcall TFT_DATA_TEMP
	; WERT aus Tabelle laden		
	LPM temp1, Z+  	;(LOW)	Y2	
	LPM temp2, Z+  	;(HIGH)
	add YL,temp1
	adc YH,temp2
	mov temp,YL
	rcall TFT_DATA_TEMP
	mov temp,YH
	rcall TFT_DATA_TEMP
	rjmp TFT_PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
TFT_CURSOR_OFF:
	rcall TFT_ESC
	ldi temp,'T'
	rcall TFT_DATA_TEMP
	ldi temp,'C'
	rcall TFT_DATA_TEMP
	ldi temp,0
	rcall TFT_DATA_TEMP
	rjmp TFT_PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
TFT_PUNKTGROESSE_TEMP:
	tst temp				; Null?
	brne PC+2
	ldi temp,1
	push temp				; sichern	
	push temp
	rcall TFT_ESC
	rcall TFT_G
	rcall TFT_Z
	pop temp
	rcall TFT_DATA_TEMP	; X
	pop temp
	rjmp TFT_DATA_TEMP	; Y
; #############################################################################
; #############################################################################
; #############################################################################
TFT_HELL:
	rcall TFT_ESC
	rcall TFT_Y
	rcall TFT_H
	ldi temp,255
	rcall TFT_DATA_TEMP
	rjmp TFT_PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
TFT_INFORMATIONEN_ANZEIGEN:
	rcall TFT_ESC
	rcall TFT_T
	rcall TFT_I
	rjmp TFT_PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
TFT_ZEILE_1:
	ldi temp1,1	; SPALTE	
	ldi temp2,1	; ZEILE		
	rjmp TFT_POSITION_TEMP1_2
TFT_ZEILE_2:
	ldi temp1,1	; SPALTE	
	ldi temp2,2	; ZEILE		
	rjmp TFT_POSITION_TEMP1_2
TFT_ZEILE_3:
	ldi temp1,1	; SPALTE	
	ldi temp2,3	; ZEILE		
	rjmp TFT_POSITION_TEMP1_2
TFT_ZEILE_4:
	ldi temp1,1	; SPALTE	
	ldi temp2,4	; ZEILE		
	rjmp TFT_POSITION_TEMP1_2
TFT_ZEILE_5:
	ldi temp1,1	; SPALTE	
	ldi temp2,5	; ZEILE		
	rjmp TFT_POSITION_TEMP1_2
TFT_ZEILE_6:
	ldi temp1,1	; SPALTE	
	ldi temp2,6	; ZEILE		
	rjmp TFT_POSITION_TEMP1_2
TFT_ZEILE_7:
	ldi temp1,1	; SPALTE	
	ldi temp2,7	; ZEILE		
	rjmp TFT_POSITION_TEMP1_2
TFT_ZEILE_8:
	ldi temp1,1	; SPALTE	
	ldi temp2,8	; ZEILE		
	rjmp TFT_POSITION_TEMP1_2
TFT_ZEILE_9:
	ldi temp1,1	; SPALTE	
	ldi temp2,9	; ZEILE		
	rjmp TFT_POSITION_TEMP1_2
TFT_ZEILE_10:
	ldi temp1,1 ; SPALTE	
	ldi temp2,10; ZEILE		
	rjmp TFT_POSITION_TEMP1_2
TFT_ZEILE_11:
	ldi temp1,1 ; SPALTE	
	ldi temp2,11; ZEILE		
	rjmp TFT_POSITION_TEMP1_2
TFT_ZEILE_12:
	ldi temp1,1 ; SPALTE	
	ldi temp2,12; ZEILE		
	rjmp TFT_POSITION_TEMP1_2
TFT_ZEILE_13:
	ldi temp1,1 ; SPALTE	
	ldi temp2,13; ZEILE		
	rjmp TFT_POSITION_TEMP1_2
TFT_ZEILE_14:
	ldi temp1,1 ; SPALTE	
	ldi temp2,14; ZEILE		
	rjmp TFT_POSITION_TEMP1_2
TFT_ZEILE_15:
	ldi temp1,1 ; SPALTE	
	ldi temp2,15; ZEILE		
	rjmp TFT_POSITION_TEMP1_2
TFT_ZEILE_16:
	ldi temp1,1 ; SPALTE	
	ldi temp2,16; ZEILE		
	rjmp TFT_POSITION_TEMP1_2
; #############################################################################
; #############################################################################
; #############################################################################
TFT_POSITION_TEMP1_2:
	rcall TFT_ESC
	ldi temp,'T'
	rcall TFT_DATA_TEMP
	ldi temp,'P'
	rcall TFT_DATA_TEMP
	mov temp,temp1		; SPALTE	
	rcall TFT_DATA_TEMP
	mov temp,temp2		; ZEILE		
	rcall TFT_DATA_TEMP
	rjmp TFT_PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
TFT_NEXT_ZEILE:
	ldi temp,13
	rcall TFT_DATA_TEMP
	ldi temp,10
	rcall TFT_DATA_TEMP
	rjmp TFT_PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
TFT_FARBE_TEXT_ROT:
	ldi temp1,(FARBE_ROT)
	rjmp TFT_FARBE_TEXT_TEMP1
TFT_FARBE_TEXT_GRUEN:
	ldi temp1,(FARBE_GRUEN)
	rjmp TFT_FARBE_TEXT_TEMP1
TFT_FARBE_TEXT_BLAU:
	ldi temp1,(FARBE_BLAU)
	rjmp TFT_FARBE_TEXT_TEMP1
TFT_FARBE_TEXT_GELB:
	ldi temp1,(FARBE_GELB)
	rjmp TFT_FARBE_TEXT_TEMP1
TFT_FARBE_TEXT_WEISS:
	ldi temp1,(FARBE_WEISS)
	rjmp TFT_FARBE_TEXT_TEMP1
TFT_FARBE_TEXT_GRAU:
	ldi temp1,(FARBE_GRAU)
	rjmp TFT_FARBE_TEXT_TEMP1
; #############################################################################
TFT_FARBE_TEXT_TEMP1:
	rcall TFT_ESC
	rcall TFT_F
	rcall TFT_T
	mov temp,temp1		; Farbwert	
	rcall TFT_DATA_TEMP
	ldi temp,1			; schwarz	
	rjmp  TFT_DATA_TEMP
; #############################################################################
; #############################################################################
; #############################################################################
TFT_FARBE_GRAFIC_ROT:
	ldi temp1,(FARBE_ROT)
	rjmp TFT_FARBE_GRAFIC_TEMP1
; #############################################################################
TFT_FARBE_GRAFIC_GRUEN:
	ldi temp1,(FARBE_GRUEN)
	rjmp TFT_FARBE_GRAFIC_TEMP1
; #############################################################################
TFT_FARBE_GRAFIC_BLAU:
	ldi temp1,(FARBE_BLAU)
	rjmp TFT_FARBE_GRAFIC_TEMP1
; #############################################################################
TFT_FARBE_GRAFIC_GELB:
	ldi temp1,(FARBE_GELB)
	rjmp TFT_FARBE_GRAFIC_TEMP1
; #############################################################################
TFT_FARBE_GRAFIC_WEISS:
	ldi temp1,(FARBE_WEISS)
	rjmp TFT_FARBE_GRAFIC_TEMP1
; #############################################################################
TFT_FARBE_GRAFIC_GRAU:
	ldi temp1,(FARBE_GRAU)
	rjmp TFT_FARBE_GRAFIC_TEMP1
; #############################################################################
TFT_FARBE_GRAFIC_TEMP1:
	rcall TFT_ESC
	rcall TFT_F
	rcall TFT_G
	mov temp,temp1		; Farbwert	
	rcall TFT_DATA_TEMP
	ldi temp,1			; schwarz	
	rcall TFT_DATA_TEMP
	rcall TFT_PAKET_SENDEN
ret
;######################################################################## 
;########################################################################
;######################################################################## 
TFT_TEXT_Z:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	brne TFT_TEXT_Z_w 	; Sprung
	rjmp TFT_PAKET_SENDEN
TFT_TEXT_Z_w:
	rcall TFT_DATA_TEMP
	rjmp TFT_TEXT_Z
; #############################################################################
; #############################################################################
; #############################################################################
; links unten (0,0)															   
; rechts oben (319,239)														   
; 320 x 240																	   
TFT_PUNKT_X_Y:
	mov temp1,XL
	mov temp2,XH

	ldi temp3,LOW (240-1)
	ldi temp4,HIGH(240-1)
	sub temp3,YL
	sbc temp4,YH
;-------------------------------------------------------------------------------
; X-Fehlerprfung																
	cpi temp2,HIGH(320-1)
	breq TFT_PUNKT_XL
	brsh TFT_PUNKT_X_ERROR
	brlo TFT_PUNKT_X_OK
TFT_PUNKT_XL:
	cpi temp1,LOW (320-1)
	breq TFT_PUNKT_X_OK
	brsh TFT_PUNKT_X_ERROR
	brlo TFT_PUNKT_X_OK
TFT_PUNKT_X_ERROR:
	ldi temp1,LOW (320-1)
	ldi temp2,HIGH(320-1)
TFT_PUNKT_X_OK:
;-------------------------------------------------------------------------------
; Y-Fehlerprfung																
	cpi temp4,HIGH(240-1)
	breq TFT_PUNKT_YL
	brsh TFT_PUNKT_Y_ERROR
	brlo TFT_PUNKT_Y_OK
TFT_PUNKT_YL:
	cpi temp3,LOW (240-1)
	breq TFT_PUNKT_Y_OK
	brsh TFT_PUNKT_Y_ERROR
	brlo TFT_PUNKT_Y_OK
TFT_PUNKT_Y_ERROR:
	ldi temp3,LOW (0)
	ldi temp4,HIGH(0)
TFT_PUNKT_Y_OK:
;-------------------------------------------------------------------------------
TFT_PUNKT_RUN:
	rcall TFT_ESC
	rcall TFT_G
	rcall TFT_P
	mov temp,temp1
	rcall TFT_DATA_TEMP	; X1(low)	
	mov temp,temp2
	rcall TFT_DATA_TEMP	; X1(HIGH)	
	mov temp,temp3
	rcall TFT_DATA_TEMP	; Y1(low)	
	mov temp,temp4
	rcall TFT_DATA_TEMP	; Y1(HIGH)	
	rjmp TFT_PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
TFT_LINIE_HORIZONTAL_Y:
	ldi temp1,LOW (0)		; X1
	ldi temp2,HIGH(0)		
	mov temp3,YL			; Y1
	mov temp4,YH

	ldi temp5,LOW (320-1)	; X2
	ldi temp6,HIGH(320-1)		
	mov temp7,YL			; Y2
	mov temp8,YH
	rjmp TFT_LINIE_TEMP1_8
; #############################################################################
; #############################################################################
; #############################################################################
TFT_LINIE_VERTIKAL_X:
	mov temp1,XL			; X1
	mov temp2,XH
	ldi temp3,LOW (0)		; Y1
	ldi temp4,HIGH(0)		

	mov temp5,XL			; X2
	mov temp6,XH
	ldi temp7,LOW (240-1)	; Y2
	ldi temp8,HIGH(240-1)		
	rjmp TFT_LINIE_TEMP1_8
; #############################################################################
; #############################################################################
; #############################################################################
; 320x240																		
TFT_LINIE_TEMP1_8:
	ldi ZL,LOW (240-1)	
	ldi ZH,HIGH(240-1)	
	sub ZL,temp3
	sbc ZH,temp4
	mov temp3,ZL
	mov temp4,ZH

	ldi ZL,LOW (240-1)	
	ldi ZH,HIGH(240-1)	
	sub ZL,temp7
	sbc ZH,temp8
	mov temp7,ZL
	mov temp8,ZH

	rcall TFT_ESC
	rcall TFT_G
	rcall TFT_D
	mov temp,temp1
	rcall TFT_DATA_TEMP	; X1(low)	
	mov temp,temp2
	rcall TFT_DATA_TEMP	; X1(HIGH)	
	mov temp,temp3
	rcall TFT_DATA_TEMP	; Y1(low)	
	mov temp,temp4
	rcall TFT_DATA_TEMP	; Y1(HIGH)	
	mov temp,temp5
	rcall TFT_DATA_TEMP	; X2(low)	
	mov temp,temp6
	rcall TFT_DATA_TEMP	; x2(HIGH)	
	mov temp,temp7
	rcall TFT_DATA_TEMP	; Y2(low)	
	mov temp,temp8
	rcall TFT_DATA_TEMP	; Y2(HIGH)	
	rjmp TFT_PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
; #############################################################################
; #############################################################################
; #############################################################################
; PAKET-Puffer mit DATENBYTES laden, wird per "PAKET_SENDEN" in das Display		
; gesendet																		
;																				
;	inp: temp																	
;																				
TFT_DATA_TEMP:
	push ZL	; Sicherungskopie	
	push ZH
	push temp
	push temp1
;-----------------------------------------------------------------------------
	; Z-ZEIGER			
	ldi ZL,LOW (adr_TFT_TX_DATEN)
	ldi ZH,HIGH(adr_TFT_TX_DATEN)
	LDS temp1, (adr_TFT_TX_ZEIGER)
	add ZL,temp1
	adc ZH,NULL
	ST Z,temp						; speichern nach Z	
	inc temp1
	STS(adr_TFT_TX_ZEIGER),temp1	; Zeiger speichern	
	; Puffer zu voll ?	
	cpi temp1,100
	brlo TFT_DATA_FERTIG
	rcall TFT_PAKET_SENDEN
;-----------------------------------------------------------------------------
TFT_DATA_FERTIG:
	pop temp1	; wiederherstellen (sicherungskopie)
	pop temp
	pop ZH
	pop ZL
	ret
; #############################################################################
; #############################################################################
; #############################################################################
; komplettes Paket zum Display senden 											
;																				
; <DC1> <LEN> <DATA> <PS>														
;																				
TFT_PAKET_SENDEN:
	; len = NULL ?
	LDS temp,(adr_TFT_TX_ZEIGER)
	tst temp
	brne TFT_PAKET_SENDEN_RUN
	ret
;-----------------------------------------------------------------------------
TFT_PAKET_SENDEN_RUN:
	; START				
	ldi temp1,(TWI_ADRESSE_TFT)
	rcall TWI_MT_START_TEMP1	; 
	tst ERROR_TWI				; Error	? 
	breq TFT_PAKET_SENDEN_ACTION
	call TWI_STOP
	ret
;-----------------------------------------------------------------------------
TFT_PAKET_SENDEN_ACTION:
	; <DC1>				
	ldi temp1,17			
	mov temp9,temp1						; PS				
	rcall TWI_MT_DATA_TEMP1
	; len				
	LDS temp1,(adr_TFT_TX_ZEIGER)
	add temp9,temp1						; PS				
	rcall TWI_MT_DATA_TEMP1
	; DATA				
	LDS temp8, (adr_TFT_TX_ZEIGER)
	ldi ZL,LOW (adr_TFT_TX_DATEN)
	ldi ZH,HIGH(adr_TFT_TX_DATEN)
;-----------------------------------------------------------------------------
TFT_PAKET_SENDEN_D:
	LD temp1,Z+
	add temp9,temp1						; PS
	rcall TWI_MT_DATA_TEMP1
	dec temp8
	brne TFT_PAKET_SENDEN_D
	; BCC (PRFSUMME)	
	mov temp1,temp9						; PS
	rcall TWI_MT_DATA_TEMP1
	rcall TWI_STOP
;-----------------------------------------------------------------------------
	; ANTWORT			
	rcall TFT_PAKET_ANTWORT_TEMP1
	cpi temp1,6
	brne TFT_PAKET_SENDEN
;-----------------------------------------------------------------------------
	; NULL				
	STS(adr_TFT_TX_ZEIGER),NULL
	ret
; #############################################################################
; #############################################################################
; #############################################################################
; Antwortbyte vom DISPLAY anfordern												
;																				
; OUT: temp1																	
;																			 	
TFT_PAKET_ANTWORT_TEMP1:
	; START				
	ldi temp1,(TWI_ADRESSE_TFT)
	rcall TWI_MR_START_TEMP1
	; DATENBYTE abholen	
	rcall TWI_MR_DATA_LAST_TEMP1
	rcall TWI_STOP
ret
; #############################################################################
; #############################################################################
; #############################################################################
; Pufferinformation vom Display anfordern										
;																				
; OUT: temp1																	
;																			 	
TFT_PAKET_PUFFERINFORMATIONEN_ANFORDERN_TEMP1:
	; START		
	ldi temp1,(TWI_ADRESSE_TFT)
	rcall TWI_MT_START_TEMP1	; 
	; <DC2>		
	ldi temp1,18			
	mov temp9,temp1			; PS
	rcall TWI_MT_DATA_TEMP1
	; len		
	ldi temp1,1
	add temp9,temp1			; PS
	rcall TWI_MT_DATA_TEMP1
	; DATA		
	ldi temp1,'I'
	add temp9,temp1			; PS
	rcall TWI_MT_DATA_TEMP1
	; BCC (PRFSUMME)	
	mov temp1,temp9
	rcall TWI_MT_DATA_TEMP1
	rcall TWI_STOP
;-----------------------------------------------------------------------------
	; ANTWORT			
	rcall TFT_PAKET_ANTWORT_TEMP1
	cpi temp1,6
	brne TFT_PAKET_PUFFERINFORMATIONEN_ANFORDERN_TEMP1
	rcall TWI_STOP
;-----------------------------------------------------------------------------
	; DATEN				
	ldi temp1,(TWI_ADRESSE_TFT)
	rcall TWI_MR_START_TEMP1
	rcall TWI_MR_DATA_TEMP1	; <DC2>		
	rcall TWI_MR_DATA_TEMP1	; <len> (2)	
	rcall TWI_MR_DATA_TEMP1	; Anzahl abholbereiter BYTES
	push temp1
	rcall TWI_MR_DATA_TEMP1	; verfgbarer Platz im Puffer
	rcall TWI_MR_DATA_LAST_TEMP1	; PS		
	rcall TWI_STOP
	pop temp1
ret
; #############################################################################
; #############################################################################
; #############################################################################
; Inhalt DISPLAY-SENDEPUFFER anfordern											
; OUT: temp1(ANZAHL BYTES)+SRAM													
;																				
TFT_PAKET_INHALT_SENDEPUFFER_ANFORDERN_TEMP1_SRAM4:
	; SRAM clear		
	STS(adr_TFT_RX_DATEN+0),NULL
	STS(adr_TFT_RX_DATEN+1),NULL
	STS(adr_TFT_RX_DATEN+2),NULL
	STS(adr_TFT_RX_DATEN+3),NULL
	; START				
	ldi temp1,(TWI_ADRESSE_TFT)
	rcall TWI_MT_START_TEMP1	; 
	; <DC2>				
	ldi temp1,18			
	mov temp9,temp1			; PS
	rcall TWI_MT_DATA_TEMP1
	; len				
	ldi temp1,1
	add temp9,temp1			; PS
	rcall TWI_MT_DATA_TEMP1
	; DATA				
	ldi temp1,'S'
	add temp9,temp1			; PS
	rcall TWI_MT_DATA_TEMP1
	; BCC (PRFSUMME)	
	mov temp1,temp9
	rcall TWI_MT_DATA_TEMP1
	rcall TWI_STOP
;-----------------------------------------------------------------------------
	; ANTWORT			
	rcall TFT_PAKET_ANTWORT_TEMP1
	cpi temp1,6
	brne TFT_PAKET_INHALT_SENDEPUFFER_ANFORDERN_TEMP1_SRAM4
	rcall TWI_STOP
;-----------------------------------------------------------------------------
	ldi temp1,(TWI_ADRESSE_TFT)
	rcall TWI_MR_START_TEMP1
	rcall TWI_MR_DATA_TEMP1	; <DC1>
	rcall TWI_MR_DATA_TEMP1	; <len>
	push temp1
	tst temp1
	breq TFT_PAKET_INHALT_SENDEPUFFER_ANFORDERN_E
	; Schleife		
	mov temp9,temp1
	; Z-ZEIGER		
	ldi ZL,LOW (adr_TFT_RX_DATEN)
	ldi ZH,HIGH(adr_TFT_RX_DATEN)
TFT_PAKET_INHALT_SENDEPUFFER_ANFORDERN_S:
	rcall TWI_MR_DATA_TEMP1
	ST Z+,temp1
	dec temp9
	brne TFT_PAKET_INHALT_SENDEPUFFER_ANFORDERN_S
TFT_PAKET_INHALT_SENDEPUFFER_ANFORDERN_E:
	rcall TWI_MR_DATA_LAST_TEMP1	; PS
	rcall TWI_STOP
	pop temp1									; Anzahl Bytes	
ret
; #############################################################################
; #############################################################################
; #############################################################################
; #############################################################################
; #############################################################################
; #############################################################################
TFT_ESC:
	ldi temp,27
	rjmp TFT_DATA_TEMP
; #############################################################################
TFT_SPACE5:
	ldi temp,' ' ; SPACE
	rcall TFT_DATA_TEMP
TFT_SPACE4:
	ldi temp,' ' ; SPACE
	rcall TFT_DATA_TEMP
TFT_SPACE3:
	ldi temp,' ' ; SPACE
	rcall TFT_DATA_TEMP
TFT_SPACE2:
	ldi temp,' ' ; SPACE
	rcall TFT_DATA_TEMP
TFT_SPACE:
	ldi temp,' ' ; SPACE
	rjmp TFT_DATA_TEMP
; #############################################################################
TFT_MINUS:
	ldi temp,'-' 
	rjmp TFT_DATA_TEMP
; #############################################################################
TFT_PUNKT:
	ldi temp,'.' 
	rjmp TFT_DATA_TEMP
; #############################################################################
TFT_DOPPELPUNKT:
	ldi temp,':' 
	rjmp TFT_DATA_TEMP
; #############################################################################
TFT_DOPPELPUNKT_SPACE:
	rcall TFT_DOPPELPUNKT
	rjmp TFT_SPACE
; #############################################################################
TFT_SCHRAEGSTRICH:
	ldi temp,'/' 
	rjmp TFT_DATA_TEMP
; #############################################################################
TFT_KLAMMER_AUF:
	ldi temp,'(' 
	rjmp TFT_DATA_TEMP
; #############################################################################
TFT_KLAMMER_ZU:
	ldi temp,')' 
	rjmp TFT_DATA_TEMP
; #############################################################################
; #############################################################################
TFT_0:
	ldi temp,'0' 
	rjmp TFT_DATA_TEMP
TFT_1:
	ldi temp,'1' 
	rjmp TFT_DATA_TEMP
TFT_2:
	ldi temp,'2' 
	rjmp TFT_DATA_TEMP
TFT_3:
	ldi temp,'3' 
	rjmp TFT_DATA_TEMP
TFT_4:
	ldi temp,'4' 
	rjmp TFT_DATA_TEMP
TFT_5:
	ldi temp,'5' 
	rjmp TFT_DATA_TEMP
TFT_6:
	ldi temp,'6' 
	rjmp TFT_DATA_TEMP
TFT_7:
	ldi temp,'7' 
	rjmp TFT_DATA_TEMP
TFT_8:
	ldi temp,'8' 
	rjmp TFT_DATA_TEMP
TFT_9:
	ldi temp,'9' 
	rjmp TFT_DATA_TEMP
; #############################################################################
; #############################################################################
TFT_A:
	ldi temp,'A' 
	rjmp TFT_DATA_TEMP
TFT_B:
	ldi temp,'B' 
	rjmp TFT_DATA_TEMP
TFT_C:
	ldi temp,'C' 
	rjmp TFT_DATA_TEMP
TFT_D:
	ldi temp,'D' 
	rjmp TFT_DATA_TEMP
TFT_E:
	ldi temp,'E' 
	rjmp TFT_DATA_TEMP
TFT_F:
	ldi temp,'F' 
	rjmp TFT_DATA_TEMP
TFT_G:
	ldi temp,'G' 
	rjmp TFT_DATA_TEMP
TFT_H:
	ldi temp,'H' 
	rjmp TFT_DATA_TEMP
TFT_I:
	ldi temp,'I' 
	rjmp TFT_DATA_TEMP
TFT_J:
	ldi temp,'J' 
	rjmp TFT_DATA_TEMP
TFT_K:
	ldi temp,'K' 
	rjmp TFT_DATA_TEMP
TFT_L:
	ldi temp,'L' 
	rjmp TFT_DATA_TEMP
TFT_M:
	ldi temp,'M' 
	rjmp TFT_DATA_TEMP
TFT_m_:
	ldi temp,'m' 
	rjmp TFT_DATA_TEMP
TFT_N:
	ldi temp,'N' 
	rjmp TFT_DATA_TEMP
TFT_O:
	ldi temp,'O' 
	rjmp TFT_DATA_TEMP
TFT_P:
	ldi temp,'P' 
	rjmp TFT_DATA_TEMP
TFT_Q:
	ldi temp,'Q' 
	rjmp TFT_DATA_TEMP
TFT_R:
	ldi temp,'R' 
	rjmp TFT_DATA_TEMP
TFT_S:
	ldi temp,'S' 
	rjmp TFT_DATA_TEMP
TFT_T:
	ldi temp,'T' 
	rjmp TFT_DATA_TEMP
TFT_U:
	ldi temp,'U' 
	rjmp TFT_DATA_TEMP
TFT_V:
	ldi temp,'V' 
	rjmp TFT_DATA_TEMP
TFT_W:
	ldi temp,'W' 
	rjmp TFT_DATA_TEMP
TFT_X:
	ldi temp,'X' 
	rjmp TFT_DATA_TEMP
TFT_Y:
	ldi temp,'Y' 
	rjmp TFT_DATA_TEMP
TFT_Z:
	ldi temp,'Z' 
	rjmp TFT_DATA_TEMP
;-------------------------------------------------------------------------------
TFT_x_:
	ldi temp,'x' 
	rjmp TFT_DATA_TEMP



