; ##############################################################################
; ##############################################################################
; ##############################################################################
; 16-BIT-TIMER																	
;																				
; CS32 CS31 CS30																
;   0 	0 	0 	No clock source (Timer/Counter stopped).						
;   0 	0 	1 	clkI/1 (No prescaling)											
; 	0 	1 	0 	clkI/8 (From prescaler)											
; *	0 	1 	1 	clkI/64 (From prescaler)										
; 	1 	0 	0 	clkI/256 (From prescaler)										
; 	1 	0 	1 	clkI/1024 (From prescaler)										
; 	1 	1 	0 	External clock source on Tn pin. Clock on falling edge.			
; 	1 	1 	1 	External clock source on Tn pin. Clock on rising edge.			
;																				
;Uhr-Timer																		
TIMER3_INITIALISIERUNG:
; 22.000.000:64=343.750 :10 =34.375
.equ TIM3WERT=65535-34375
	; TCCR3A  Timer/Counter 3 Control Register A			
	ldi temp, (0<<COM3A1)| (0<<COM3A0)|(0<<COM3B1)|(0<<COM3B0)|(0<<WGM31)|(0<<WGM30)
	STS TCCR3A,temp
	; TCCR3B  Timer/Counter 3 Control Register B			
	ldi temp, (0<<ICNC3)| (0<<ICES3)|(0<<WGM33)|(0<<WGM32)|(0<<CS32)|(1<<CS31)|(1<<CS30)
	STS TCCR3B,temp
	; TCCR3C  Timer/Counter 3 Control Register C			
	ldi temp, (0<<FOC3A)|(0<<FOC3B)
	STS TCCR3C,temp
	; TIMSK3  Timer/Counter3 Interrupt Mask Register		
	ldi temp, (0<<ICIE3)| (0<<OCIE3B)|(0<<OCIE3A)|(1<<TOIE3)
	STS TIMSK3,temp
	; OCR3AH and OCR3AL  Output Compare Register 3 A		
	ldi temp,HIGH(TIM3WERT)
	STS OCR3AH,temp
	ldi temp,LOW (TIM3WERT)
	STS OCR3AL,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIM3_OVF:
	push TEMP		    ; Sichern von "TEMP" im Stack			
	in	 TEMP,SREG		; Einlesen des SREG 					
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)	
	ldi temp,LOW (TIM3WERT)
	STS TCNT3L,temp
	ldi temp,HIGH (TIM3WERT)
	STS TCNT3H,temp

	rcall UHR


	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)		
	out	SREG,TEMP		; Wiederherstellen von SREG				
	pop	TEMP			; Wiederherstellen von "TEMP"
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
UHR:
	LDS temp,(adr_ss_VT)
	inc temp
	cpi temp,10
	brsh UHR_ss
	STS(adr_ss_VT),temp
	ret
;-------------------------------------------------------------------------------
UHR_ss:
	STS(adr_ss_VT),NULL

	LDS temp,(adr_ss)
	inc temp
	cpi temp,60
	brsh UHR_mm
	STS(adr_ss),temp
	ret
;-------------------------------------------------------------------------------
UHR_mm:
	STS(adr_ss),NULL

	LDS temp,(adr_mm)
	inc temp
	cpi temp,60
	brsh UHR_hh
	STS(adr_mm),temp
	ret
;-------------------------------------------------------------------------------
UHR_hh:
	STS(adr_mm),NULL

	LDS temp,(adr_hh)
	inc temp
	cpi temp,24
	brsh UHR_TAG
	STS(adr_hh),temp
	ret
;-------------------------------------------------------------------------------
UHR_TAG:
	STS(adr_hh),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
UHR_NULL:
	STS(adr_SS_VT),NULL
	STS(adr_ss),NULL
	STS(adr_mm),NULL
	STS(adr_hh),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
