;												
; HDD SD an ATmega1284P							
; Bernhard.Erfurt@gmx.de						
; 07.2018										
;												


; ATmega1284P 									
.include "m1284pdef.inc"
; REGISTER										
.def ERROR		= R7
.def ERROR_TWI	= R8

.def SECTOR0	= R9
.def SECTOR1	= R10
.def SECTOR2	= R11
.def SECTOR3	= R12

.def NULL 		= R13
.def EINS 		= R14
.def VOLL		= R15

.def temp 		= R16
.def temp1 		= R17
.def temp2 		= R18
.def temp3 		= R19
.def temp4 		= R20
.def temp5 		= R21
.def temp6 		= R22
.def temp7 		= R23
.def temp8 		= R24
.def temp9 		= R25

; KONSTANTEN									
.equ TAKT							=22000000	; 22 MHz	
; TFT DISPLAY									
.equ TWI_ADRESSE_TFT				= 110
; Error-Codes									
.equ ERROR_IDE_BUSHY				= 0xA0
.equ ERROR_IDE_READ					= 0xEE
.equ ERROR_IDE_WRITE				= 0xEF

.equ ERROR_CODE_SD_INI				= 0xE0
.equ ERROR_CODE_SD_BLOCKLAENGE		= 0xE1
.equ ERROR_CODE_SD_READ				= 0xEA
.equ ERROR_CODE_SD_READ_MULTIPLE	= 0xEB
.equ ERROR_CODE_SD_WRITE			= 0xEC
.equ ERROR_CODE_SD_WRITE_MULTIPLE	= 0xED



; TASTE "A"										
.equ TASTE_A_PIN_NR			= 2
.equ TASTE_A_PIN			= PINC
.equ TASTE_A_DDR			= DDRC
.equ TASTE_A_PORT			= PORTC
.equ TASTE_A				= 1
.equ TASTE_MENUE_MINUS		= 1
; TASTE "B"										
.equ TASTE_B_PIN_NR			= 3
.equ TASTE_B_PIN			= PINC
.equ TASTE_B_DDR			= DDRC
.equ TASTE_B_PORT			= PORTC
.equ TASTE_B				= 2
.equ TASTE_MENUE_PLUS		= 2
; TASTE "C"										
.equ TASTE_C_PIN_NR			= 4
.equ TASTE_C_PIN			= PINC
.equ TASTE_C_DDR			= DDRC
.equ TASTE_C_PORT			= PORTC
.equ TASTE_C				= 4
.equ TASTE_MINUS			= 4
; TASTE "D"										
.equ TASTE_D_PIN_NR			= 5
.equ TASTE_D_PIN			= PINC
.equ TASTE_D_DDR			= DDRC
.equ TASTE_D_PORT			= PORTC
.equ TASTE_D				= 8
.equ TASTE_PLUS				= 8
; TASTE "E"										
.equ TASTE_E_PIN_NR			= 6
.equ TASTE_E_PIN			= PINC
.equ TASTE_E_DDR			= DDRC
.equ TASTE_E_PORT			= PORTC
.equ TASTE_E				= 16
; LCD (DATA)									
.equ LCD_DATA0_DDR			= DDRC
.equ LCD_DATA1_DDR			= DDRC
.equ LCD_DATA2_DDR			= DDRC
.equ LCD_DATA3_DDR			= DDRC
.equ LCD_DATA0_PORT			= PORTC
.equ LCD_DATA1_PORT			= PORTC
.equ LCD_DATA2_PORT			= PORTC
.equ LCD_DATA3_PORT			= PORTC
.equ LCD_DATA0				= 2
.equ LCD_DATA1				= 3
.equ LCD_DATA2				= 4
.equ LCD_DATA3				= 5
; LCD RS (Befehl/DATEN)							
.equ LCD_RS_DDR				= DDRC
.equ LCD_RS_PORT			= PORTC
.equ LCD_RS					= 6
; LCD_ENABLE									
.equ LCD_EN_DDR				= DDRC
.equ LCD_EN_PORT			= PORTC
.equ LCD_EN					= 7
; LED-ROT										
.equ LED_ROT_PIN_NR			= 0
.equ LED_ROT_DDR			= DDRB
.equ LED_ROT_PORT			= PORTB
; RS232											
.equ RS232_PIN_NR			= 1
.equ RS232_DDR				= DDRB
.equ RS232_PORT				= PORTB
; IDE-WR										
.equ IDE_WR_PIN_NR			= 2
.equ IDE_WR_PIN				= PINB
.equ IDE_WR_PORT			= PORTB
.equ IDE_WR_DDR				= DDRB
; IDE-RD										
.equ IDE_RD_PIN_NR			= 3
.equ IDE_RD_PIN				= PINB
.equ IDE_RD_PORT			= PORTB
.equ IDE_RD_DDR				= DDRB
; SPI-CS										
.equ SPI_CS_PIN_NR			= 4
.equ SPI_CS_DDR				= DDRB
.equ SPI_CS_PORT			= PORTB
; SPI-MOSI										
.equ SPI_MOSI_PIN_NR		= 5
.equ SPI_MOSI_DDR			= DDRB
.equ SPI_MOSI_PORT			= PORTB
; SPI-MISO										
.equ SPI_MISO_PIN_NR		= 6
.equ SPI_MISO_DDR			= DDRB
.equ SPI_MISO_PORT			= PORTB
; SPI-SCK										
.equ SPI_SCK_PIN_NR			= 7
.equ SPI_SCK_DDR			= DDRB
.equ SPI_SCK_PORT			= PORTB
; TWI-SCL										
.equ TWI_SCL_PIN_NR			= 0
.equ TWI_SCL_PORT			= PORTC
; TWI-SDA										
.equ TWI_SDA_PIN_NR			= 1
.equ TWI_SDA_PORT			= PORTC
; IDE-A2										
.equ IDE_A2_PIN_NR			= 2
.equ IDE_A2_PIN				= PINC
.equ IDE_A2_PORT			= PORTC
.equ IDE_A2_DDR				= DDRC
; IDE-C1										
.equ IDE_CS1_PIN_NR			= 3
.equ IDE_CS1_PIN			= PINC
.equ IDE_CS1_PORT			= PORTC
.equ IDE_CS1_DDR			= DDRC
; IDE-C0										
.equ IDE_CS0_PIN_NR			= 4
.equ IDE_CS0_PIN			= PINC
.equ IDE_CS0_PORT			= PORTC
.equ IDE_CS0_DDR			= DDRC
; IDE-A0										
.equ IDE_A0_PIN_NR			= 5
.equ IDE_A0_PIN				= PINC
.equ IDE_A0_PORT			= PORTC
.equ IDE_A0_DDR				= DDRC
; IDE-A1										
.equ IDE_A1_PIN_NR			= 6
.equ IDE_A1_PIN				= PINC
.equ IDE_A1_PORT			= PORTC
.equ IDE_A1_DDR				= DDRC
; IDE-DATA0										
.equ IDE_DATA0_PORT			= PORTA
.equ IDE_DATA0_DDR			= DDRA
.equ IDE_DATA0_PIN			= PINA
; IDE-DATA1										
.equ IDE_DATA1_PORT			= PORTD
.equ IDE_DATA1_DDR			= DDRD
.equ IDE_DATA1_PIN			= PIND
; SRAM-BELEGUNG Adr:0x0100-0x40FF(256-16.639=16383)					
.equ adr_DATEN						=SRAM_START		; 0x0060 START Adresse 		

.equ adr_MENUE						=SRAM_START+1
.equ adr_TASTE						=SRAM_START+2

.equ adr_ss_VT						=SRAM_START+10		
.equ adr_ss							=SRAM_START+11		; Sekunden					
.equ adr_mm							=SRAM_START+12		; Minuten					
.equ adr_hh							=SRAM_START+13		; Stunden					
.equ adr_TAG						=SRAM_START+14		; TAG						

.equ adr_ZUFALLSZAHL				=SRAM_START+15

.equ adr_ZAEHLER0					=SRAM_START+16
.equ adr_ZAEHLER1					=SRAM_START+17
.equ adr_ZAEHLER2					=SRAM_START+18
.equ adr_ZAEHLER3					=SRAM_START+19

.equ adr_IDE_SECTOR_MAX0			=SRAM_START+100		; Secector max		
.equ adr_IDE_SECTOR_MAX1			=SRAM_START+101		; Secector max		
.equ adr_IDE_SECTOR_MAX2			=SRAM_START+102		; Secector max		
.equ adr_IDE_SECTOR_MAX3			=SRAM_START+103		; Secector max		

.equ adr_IDE_CAPACITY_MB0			=SRAM_START+104		; Capacity in MB	
.equ adr_IDE_CAPACITY_MB1			=SRAM_START+105		; Capacity in MB	
.equ adr_IDE_CAPACITY_MB2			=SRAM_START+106		; Capacity in MB	
.equ adr_IDE_CAPACITY_MB3			=SRAM_START+107		; Capacity in MB	

.equ adr_IDE_REGISTER_STATUS		=SRAM_START+110		; Status Register	
.equ adr_IDE_REGISTER_ERROR			=SRAM_START+111		; Error-Register	
.equ adr_IDE_REGISTER_ERROR_LAST	=SRAM_START+112		; Error-Register (letzter)	
.equ adr_IDE_TAKT_SLOW				=SRAM_START+113		; 1=lange Pause		
.equ adr_IDE_CHS_LBA				=SRAM_START+114		; 0=CHS 1=LBA		

.equ adr_IDE_IDENTIFY_CYL_L			=SRAM_START+116		; CYL				
.equ adr_IDE_IDENTIFY_CYL_H			=SRAM_START+117		; CYL				
.equ adr_IDE_IDENTIFY_HEAD			=SRAM_START+118		; Head				
.equ adr_IDE_IDENTIFY_SEC			=SRAM_START+119		; Secectoren		

.equ adr_IDE_CHS_SEC				=SRAM_START+120		; nur fr CHS		
.equ adr_IDE_CHS_HEAD				=SRAM_START+121		; nur fr CHS		
.equ adr_IDE_CHS_CYL_L				=SRAM_START+122		; nur fr CHS		
.equ adr_IDE_CHS_CYL_H				=SRAM_START+123		; nur fr CHS		

.equ adr_SD_SECTOR_MAX0				=SRAM_START+200		; Secector max		
.equ adr_SD_SECTOR_MAX1				=SRAM_START+201		; Secector max		
.equ adr_SD_SECTOR_MAX2				=SRAM_START+202		; Secector max		
.equ adr_SD_SECTOR_MAX3				=SRAM_START+203		; Secector max		

.equ adr_SD_CAPACITY_MB0			=SRAM_START+204		; Capacity in MB	
.equ adr_SD_CAPACITY_MB1			=SRAM_START+205		; Capacity in MB	
.equ adr_SD_CAPACITY_MB2			=SRAM_START+206		; Capacity in MB	
.equ adr_SD_CAPACITY_MB3			=SRAM_START+207		; Capacity in MB	

.equ adr_SD_SDHC_AKTIV				= SRAM_START+210	; 0=SDSC 1=SDHC		
.equ adr_SD_CSD_READ_BL_LEN			= SRAM_START+211 	; Register CSD =>READ_BL_LEN	
.equ adr_SD_CSD_C_SIZE_0			= SRAM_START+212	; Register CSD =>C_SIZE			
.equ adr_SD_CSD_C_SIZE_1			= SRAM_START+213	; Register CSD =>C_SIZE			
.equ adr_SD_CSD_C_SIZE_MULT			= SRAM_START+214 	; Register CSD =>C_SIZE_MULT	
.equ adr_SD_CSD_MULT_L				= SRAM_START+215
.equ adr_SD_CSD_MULT_H				= SRAM_START+216

.equ adr_TWI_BEREICH_READ			=SRAM_START+1000	; BEREICH fr Master TWI/I2C	
.equ adr_TFT_TX_ZEIGER				=SRAM_START+2000	; TFT							
.equ adr_TFT_RX_DATEN				=SRAM_START+3000	; TFT							
.equ adr_TFT_TX_DATEN				=SRAM_START+4000	; TFT							

.equ adr_DATA						=SRAM_START+6000	; HDD/SD						

.equ adr_SRAM_CHECK					=SRAM_START+16300	; SRAM CHECK muss immer "S" sein	



.cseg							;Beginn eines Code-Segmentes
.org 0							;Startadresse=0				
.org 0x0000 rjmp RESET 			 ; Reset									
.org 0x0002 rjmp INTERRUPT_ERROR ;rjmp INT0 ; IRQ0							
.org 0x0004 rjmp INTERRUPT_ERROR ;rjmp INT1 ; IRQ1							
.org 0x0006 rjmp INTERRUPT_ERROR ;rjmp INT2 ; IRQ2							
.org 0x0008 rjmp INTERRUPT_ERROR ;rjmp PCINT0 ; PCINT0						
.org 0x000A rjmp INTERRUPT_ERROR ;rjmp PCINT1 ; PCINT1						
.org 0x000C rjmp INTERRUPT_ERROR ;rjmp PCINT2 ; PCINT2						
.org 0x000E rjmp INTERRUPT_ERROR ;rjmp PCINT3 ; PCINT3						
.org 0x0010 rjmp INTERRUPT_ERROR ;rjmp WDT 		; Watchdog Timeout								
.org 0x0012 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPA ; Timer2 CompareA			
.org 0x0014 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPB ; Timer2 CompareB			
.org 0x0016 rjmp INTERRUPT_ERROR ;rjmp TIM2_OVF 	; Timer2 Overflow		
.org 0x0018 rjmp INTERRUPT_ERROR ;rjmp TIM1_CAPT ; Timer1 Capture			
.org 0x001A rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPA ; Timer1 CompareA			
.org 0x001C rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPB ; Timer1 CompareB			
.org 0x001E rjmp INTERRUPT_ERROR ;rjmp TIM1_OVF 	; Timer1 Overflow		
.org 0x0020 rjmp INTERRUPT_ERROR ;rjmp TIM0_COMPA ; Timer0 CompareA			
.org 0x0022 rjmp INTERRUPT_ERROR ;rjmp TIM0_COMPB ; Timer0 CompareB			
.org 0x0024 rjmp INTERRUPT_ERROR ;rjmp TIM0_OVF 	; Timer0 Overflow		
.org 0x0026 rjmp INTERRUPT_ERROR ;rjmp SPI_STC ; SPI Transfer Complete		
.org 0x0028 rjmp INTERRUPT_ERROR ;rjmp USART0_RXC ; USART0 RX Complete		
.org 0x002A rjmp INTERRUPT_ERROR ;rjmp USART0_UDRE ; USART0,UDR Empty		
.org 0x002C rjmp INTERRUPT_ERROR ;rjmp USART0_TXC ; USART0 TX Complete		
.org 0x002E rjmp INTERRUPT_ERROR ;rjmp ANA_COMP ; Analog Comparator			
.org 0x0030 rjmp INTERRUPT_ERROR ;rjmp ADC ; ADC Conversion Complete		
.org 0x0032 rjmp INTERRUPT_ERROR ;rjmp EE_RDY ; EEPROM Ready				
.org 0x0034 rjmp INTERRUPT_ERROR ;rjmp TWI ; 2-wire Serial					
.org 0x0036 rjmp INTERRUPT_ERROR ;rjmp SPM_RDY ; SPM Ready					
.org 0x0038 rjmp INTERRUPT_ERROR ;rjmp USART1_RXC ; USART1 RX Complete		
.org 0x003A rjmp INTERRUPT_ERROR ;rjmp USART1_UDRE ; USART1,UDR Empty		
.org 0x003C rjmp INTERRUPT_ERROR ;rjmp USART1_TXC ; USART1 TX Complete		
.org 0x003E rjmp INTERRUPT_ERROR ;rjmp TIM3_CAPT ; Timer3 Capture			
.org 0x0040 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPA ; Timer3 CompareA			
.org 0x0042 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPB ; Timer3 CompareB			
.org 0x0044 rjmp TIM3_OVF 	; Timer3 Overflow		
; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	call wait_100ms
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	call wait_100ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
	ldi temp, LOW(RAMEND)		; STACK initialisieren		
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	call SRAM_CLEAR					; SRAM_CLEAR		
	call PORT_CLEAR					; Ports auf EINGANG	
	call REGISTER_CLEAR				; Register Clear	
	call STARTWERTE					; Startwerte		
	call LED_INITIALISIERUNG		; LED				
	call WDR_INITIALISIERUNG		; WDR				
	call TIMER3_INITIALISIERUNG 	; Timer 0,1s		
	call LCD_INITIALISIERUNG		; LCD				
	call TWI_INI					; TWI				
	call TWI_SCAN					; TWI				
	call TFT_INITIALISIEREN			; TFT				
	call SPI_INITIALISIERUNG		; SPI				
	call RS232_INITIALISIERUNG		; RS232				
	call IDE_INITIALISIERUNG		; IDE				
	call SD_INITIALISIERUNG			; SD				
	call PROGRAMM_CHECK				; Check				
;-------------------------------------------------------------------------------
	sei
	call LCD_CLEAR
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR										; Watch-Dog-RESET	
	call IDE_CHECK
	call SD_CHECK
	call TASTATUR_ABFRAGE
	call MENUE
	call PROGRAMM_CHECK
	call TASTATUR_WAIT
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "TIMER.asm"			; TIMER			
.include "IDE.asm"				; IDE			
.include "IDE_SONSTIGES.asm"	; IDE			
.include "SPI.asm"				; SPI			
.include "SD.asm"				; SD			
.include "SD_SONSTIGES.asm"		; SD			
.include "SONSTIGES.asm"		; sonstiges		
.include "WAIT.asm"				; wait			
.include "TWI.asm"				; TWI			
.include "TFT.asm"				; TFT			
.include "TFT_ANZEIGE.asm"		; TFT			
.include "LCD.asm"				; LCD			
.include "LCD_ANZEIGE.asm"		; LCD			
.include "LCD_TEXTE.asm"		; LCD			
.include "RS232.asm"			; RS232			
.include "MENUE.asm"			; MENUE			
; ##############################################################################
; ##############################################################################
; ##############################################################################
; LCD							
TEXT_LCD_BEGRUESSUNG_1:
.db "HDD + SD ",0
TEXT_LCD_BEGRUESSUNG_2:
.db "ATmega1284p",0
TEXT_LCD_BEGRUESSUNG_3:
.db "22MHz",0
TEXT_LCD_BEGRUESSUNG_4:
.db "07/2018",0
; TFT							
TEXT_BEGRUESSUNG_1:
.db "TFT DISPLAY 240x320",0
TEXT_BEGRUESSUNG_2:
.db "EA eDIPTFT32-ATP ",0
TEXT_BEGRUESSUNG_3:
.db "ATmega1284p",0
TEXT_BEGRUESSUNG_4:
.db "07/2018",0
